;----------------------------------------------------------------------------------------------------------------------------------------------------;
;  U7DPMI.ASM                                                                                                                                        ;
;    Scheduler COM to run the Ultima 7 family of games under Windows 9x, uses U7VXD.VXD                                                              ;
;    Gilbert ROUQUI, August 1, 2000                                                                                                                 ;
;  To run : U7DPMI or U7DPMI ABCDAlt-255 (Cheat mode Black Gate) or U7DPMI manimal (Cheat Mode Serpent Isle)                                         ;
;  Compile -D options : -DTRACE enables an event TRACE (program scheduling, int 21 and 2f events)                                                    ;
;----------------------------------------------------------------------------------------------------------------------------------------------------;

;====================================================================================================================================================;

                              title                         U7DPMI - Ultima7 Dispatcher for Windows 9x/NT

;====================================================================================================================================================;
;                             I N C L U D E S
;====================================================================================================================================================;

                              .586p
                              .xlist
                              .list

;====================================================================================================================================================;
;                             E Q U A T E S
;====================================================================================================================================================;

;====================================================================================================================================================;
;                             M A I N                       C O D E
;====================================================================================================================================================;

text                          segment                       para public use16 'CODE'

                              assume                        cs:text, ds:text
                              db                            100h dup(?)

;====================================================================================================================================================;
;
; dispatcher - Schedules the EXEs from the game, according each one's returm code
;
;====================================================================================================================================================;

dispatcher                    proc                          near
                              mov                           dx, ds
                              mov                           ah, 4ah
                              mov                           bx, offset text_end
                              add                           bx, 000fh
                              shr                           bx, 04h
                              int                           21h
                              mov                           sp, offset text_end
                              mov                           ah, 09h
                              mov                           dx, offset msg_banner
                              int                           21h

                              mov                           ah, 0fh
                              int                           10h
                              mov                           video_state, al
                              mov                           ah, 00h
                              mov                           al, 13h
                              int                           10h

                              call                          interrupt_set

                              mov                           al, 0ah

dispatch_loop:
                              mov                           program_state, al
                              xor                           esi, esi
IFDEF TRACE
                              mov                           extra_data, esi
                              call                          machine_dump_with_ds
                              call                          occurrence_dump
ENDIF
dispatch_01:
                              cmp                           al, 01h
                              jnz                           dispatch_06
                              jmp                           dispatch_exit

dispatch_06:
                              cmp                           al, 06h
                              jnz                           dispatch_02
                              mov                           executable_state, 02h
                              mov                           di, offset pgm_intro
                              mov                           si, offset arg_psw_u71
                              test                     byte ptr is_u72, 01h
                              jz                            dispatch_06_u71
                              mov                           si, offset arg_psw_u72
dispatch_06_u71:
                              call                          program_wait
                              jc                            dispatch_load_fail
                              jmp                           dispatch_loop

dispatch_02:
                              cmp                           al, 02h
                              jnz                           dispatch_03
                              mov                           executable_state, 01h
                              mov                           di, offset pgm_menu
                              mov                           si, offset arg_v
                              call                          program_wait
                              jc                            dispatch_load_fail
                              jmp                           dispatch_loop

dispatch_03:
                              cmp                           al, 03h
                              jnz                           dispatch_04
                              mov                           executable_state, 03h
                              mov                           di, offset pgm_u71
                              test                     byte ptr is_u72, 01h
                              jz                            dispatch_03_u71
                              mov                           di, offset pgm_u72
dispatch_03_u71:
                              xor                           bx, bx
                              mov                           bl, ds:[0080h]
                              cmp                           bx, 7ch
                              jl                            dispatch_03_ovf
                              sub                           bx, 03h
dispatch_03_ovf:
                              add                           bx, 0081h
                              mov                      byte ptr ds:[bx], 20h
                              inc                           bx
                              mov                      byte ptr ds:[bx], 70h
                              inc                           bx
                              mov                      byte ptr ds:[bx], 00h
                              mov                           si, 0081h
                              call                          program_wait
                              jc                            dispatch_load_fail
                              jmp                           dispatch_loop

dispatch_04:
                              cmp                           al, 04h
                              jnz                           dispatch_05
                              mov                           executable_state, 04h
                              mov                           di, offset pgm_end
                              mov                           si, offset arg_psw_u71
                              test                     byte ptr is_u72, 01h
                              jz                            dispatch_04_u71
                              mov                           si, offset arg_psw_u72
dispatch_04_u71:
                              call                          program_wait
                              jc                            dispatch_load_fail
                              jmp                           dispatch_loop

dispatch_05:
                              cmp                           al, 05h
                              jnz                           dispatch_07
                              mov                           executable_state, 01h
                              mov                           di, offset pgm_menu
                              mov                           si, offset arg_n
                              call                          program_wait
                              jc                            dispatch_load_fail
                              jmp                           dispatch_exit

dispatch_07:
                              cmp                           al, 07h
                              jnz                           dispatch_08
                              mov                           executable_state, 01h
                              mov                           di, offset pgm_menu
                              mov                           si, offset arg_c
                              call                          program_wait
                              jc                            dispatch_load_fail
                              jmp                           dispatch_loop

dispatch_08:
                              cmp                           al, 08h
                              jnz                           dispatch_0a
                              mov                           executable_state, 01h
                              mov                           di, offset pgm_extra
                              mov                           si, offset arg_u1
                              call                          program_wait
                              jc                            dispatch_load_fail
                              jmp                           dispatch_loop

dispatch_0a:
                              cmp                           al, 0ah
                              jnz                           dispatch_09
                              mov                           executable_state, 01h
                              mov                           di, offset pgm_menu
                              mov                           si, offset arg_m
                              call                          program_wait
                              jc                            dispatch_load_fail
                              jmp                           dispatch_loop

dispatch_09:
                              cmp                           al, 09h
                              jnz                           dispatch_exit
                              mov                           executable_state, 01h
                              mov                           di, offset pgm_menu
                              mov                           si, offset arg_l
                              call                          program_wait
                              jc                            dispatch_load_fail
                              jmp                           dispatch_loop

dispatch_load_fail:
                              push                          ax
                              mov                           ah, 00h
                              mov                           al, video_state
                              int                           10h
                              pop                           ax
                              mov                           dx, offset msg_error
                              jmp                           dispatch_exit_msg

dispatch_exit:
                              mov                           ah, 0fh
                              int                           10h
                              cmp                           video_state, al
                              je                            dispatch_exit_video
                              mov                           ah, 00h
                              mov                           al, video_state
                              int                           10h

dispatch_exit_video:
                              xor                           ax, ax
                              mov                           dx, offset msg_exit_u71
                              test                     byte ptr is_u72, 01
                              jz                            dispatch_exit_msg
                              mov                           dx, offset msg_exit_u72
dispatch_exit_msg:
                              push                          ax
                              mov                           ah, 09h
                              int                           21h
                              pop                           ax
dispatch_return:
                              push                          ax
                              mov                           dx, word ptr [00h+int_21]
                              mov                           cx, word ptr [02h+int_21]
                              mov                           ax, 0201h
                              mov                           bl, 21h
                              int                           31h
                              mov                           dx, word ptr [00h+int_2f]
                              mov                           cx, word ptr [02h+int_2f]
                              mov                           ax, 0201h
                              mov                           bl, 2fh
                              int                           31h
                              mov                           dx, word ptr [00h+int_03]
                              mov                           cx, word ptr [02h+int_03]
                              mov                           ax, 0201h
                              mov                           bl, 03h
                              int                           31h
IFDEF EXCP
                              mov                           dx, word ptr [00h+prot_exception]
                              mov                           cx, word ptr [02h+prot_exception]
                              mov                           ax, 0203h
                              mov                           bl, 0Eh
                              int                           31h
ENDIF
                              pop                           ax
                              mov                           ah, 4ch
                              int                           21h
dispatcher                    endp

;====================================================================================================================================================;
;
; interrupt_set - Hooks software interrupts 21 for code 3Dxx Open, and interrupt 2f for code 4310 Locate XMS
;
;====================================================================================================================================================;

interrupt_set                 proc                          near
                              push                          ax
                              mov                           ax, 3521h
                              int                           21h
                              mov                      word ptr [00h+int_21], bx
                              mov                      word ptr [02h+int_21], es
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              mov                           ax, 352fh
                              int                           21h
                              mov                      word ptr [00h+int_2f], bx
                              mov                      word ptr [02h+int_2f], es
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              mov                           ax, 3503h
                              int                           21h
                              mov                      word ptr [00h+int_03], bx
                              mov                      word ptr [02h+int_03], es
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              mov                           dx, offset interrupt_21
                              mov                           ax, 2521h
                              int                           21h
                              mov                           dx, offset interrupt_2f
                              mov                           ax, 252fh
                              int                           21h
                              mov                           ax, 3d00h
                              mov                           dx, offset pgm_u72
                              int                           21h
                              jc                            interrupt_dpmi
                              mov                           bx, ax
                              mov                           ah, 3eh
                              int                           21h
                              mov                      byte ptr is_u72, 01
interrupt_dpmi:
                              mov                           ax, 1687h
                              int                           2fh
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              or                            ax, ax
                              jnz                           interrupt_fail_real
                              mov                      word ptr [00h+ini_modesw], di
                              mov                      word ptr [02h+ini_modesw], es
                              mov                           bx, si
                              or                            bx, bx
                              jz                            interrupt_switch
                              mov                           ah, 48h
                              int                           21h
                              jc                            interrupt_fail_real
                              mov                           es, ax

interrupt_switch:
                              xor                           ax, ax
                              mov                           seg_real_ds, ds
                              mov                           seg_real_cs, cs
                              mov                           seg_real_es, es
                              mov                           seg_real_ss, ss
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              call                    dword ptr ini_modesw
                              jc                            interrupt_fail_real

interrupt_protected:
                              mov                           machine_state, 01h
                              mov                           seg_prot_ds, ds
                              mov                           seg_prot_cs, cs
                              mov                           seg_prot_es, es
                              mov                           seg_prot_ss, ss
IFDEF TRACE
                              call                          machine_dump_with_ds
                              mov                           ax, 0400h
                              int                           31h
                              push                          gs
                              push                          es
                              pop                           gs
                              call                          machine_dump_with_ds
                              pop                           gs
ENDIF
                              mov                           ax, 0305h
                              int                           31h
                              mov                           raw_modees, ax
                              mov                      word ptr [00h+raw_real_save_restore], cx
                              mov                      word ptr [02h+raw_real_save_restore], bx
                              mov                      word ptr [00h+raw_prot_save_restore], di
                              mov                      word ptr [02h+raw_prot_save_restore], si
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              mov                           ax, 0306h
                              int                           31h
                              mov                      word ptr [00h+raw_real_switch], cx
                              mov                      word ptr [02h+raw_real_switch], bx
                              mov                      word ptr [00h+raw_prot_switch], di
                              mov                      word ptr [02h+raw_prot_switch], si
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              call                          raw_mode_test

                              push                          ds
                              push                          ds
                              pop                           es
                              push                          cs
                              pop                           ds
                              mov                           si, offset callback_proc
                              mov                           di, offset real_edi
                              mov                           ax, 0303h
                              int                           31h
                              pop                           ds
                              mov                      word ptr [00h+real_callback], dx
                              mov                      word ptr [02h+real_callback], cx
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              jc                            interrupt_fail_prot

                              mov                           ax, 0201h
                              mov                           bl, 03h
                              int                           31h
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
IFDEF EXCP
                              mov                           ax, 0202h
                              mov                           bl, 0Eh
                              int                           31h
                              mov                      word ptr [00h+prot_exception], dx
                              mov                      word ptr [02h+prot_exception], cx
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              jc                            interrupt_fail_prot

                              mov                           dx, offset exception_proc
                              mov                           cx, cs
                              mov                           ax, 0203h
                              mov                           bl, 0Eh
                              int                           31h
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              jc                            interrupt_fail_prot
ENDIF
                              xor                           ax, ax
                              mov                           cx, 0001h
                              int                           31h
                              mov                           big_selector, ax
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              jc                            interrupt_fail_prot

                              mov                           ax, 000ch
                              mov                           di, offset big_descriptor
                              mov                           bx, big_selector
                              int                           31h
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              jc                            interrupt_fail_prot

                              xor                           bx, bx
                              mov                           ax, 0002h
                              int                           31h
                              mov                           seg_prot_0000, ax
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              jc                            interrupt_fail_prot

                              mov                           bx, 0A000h
                              mov                           ax, 0002h
                              int                           31h
                              mov                           seg_prot_a000, ax
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              jc                            interrupt_fail_prot

                              mov                           fs, big_selector
                              mov                           gs, seg_prot_a000
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              pop                           ax
                              ret

interrupt_fail_real:
                              mov                           ah, 00h
                              mov                           al, video_state
                              int                           10h
                              push                          ds
                              lds                           dx, dword ptr [00h+int_21]
                              mov                           ax, 2521h
                              int                           21h
                              pop                           ds
                              push                          ds
                              lds                           dx, dword ptr [00h+int_2f]
                              mov                           ax, 252fh
                              int                           21h
                              pop                           ds
                              push                          ds
                              lds                           dx, dword ptr [00h+int_03]
                              mov                           ax, 2503h
                              int                           21h
                              pop                           ds
                              mov                           ax, 4c00h
                              int                           21h

interrupt_fail_prot:
                              mov                           dx, word ptr [00h+int_21]
                              mov                           cx, word ptr [02h+int_21]
                              mov                           ax, 0201h
                              mov                           bl, 21h
                              int                           31h
                              mov                           dx, word ptr [00h+int_2f]
                              mov                           cx, word ptr [02h+int_2f]
                              mov                           ax, 0201h
                              mov                           bl, 2fh
                              int                           31h
                              mov                           dx, word ptr [00h+int_03]
                              mov                           cx, word ptr [02h+int_03]
                              mov                           ax, 0201h
                              mov                           bl, 03h
                              int                           31h
                              mov                           ax, 4c00h
                              int                           21h
interrupt_set                 endp

;====================================================================================================================================================;
;
; raw_mode_test - A performance / consistency test for DPMI Raw Mode
;
;====================================================================================================================================================;

raw_mode_test                 proc                          near
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              pusha
                              push                          es
                              sub                           sp, raw_modees
                              mov                           di, sp
                              mov                           ax, ss
                              mov                           es, ax

IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              mov                           al, 00h
                              call                    dword ptr raw_prot_save_restore

IFDEF TRACE
                              call                          machine_dump_with_ds
                              mov                           eax, dword ptr es:[00h+di]
                              mov                           ebx, dword ptr es:[04h+di]
                              mov                           ecx, dword ptr es:[08h+di]
                              mov                           edx, dword ptr es:[0ch+di]
                              call                          machine_dump_with_ds
                              mov                           eax, dword ptr es:[10h+di]
                              mov                           ebx, dword ptr es:[14h+di]
                              mov                           ecx, dword ptr es:[18h+di]
                              mov                           edx, dword ptr es:[1ch+di]
                              mov                           esi, dword ptr es:[20h+di]
                              call                          machine_dump_with_ds
ENDIF
                              mov                           real_ds, ds
                              mov                           real_ss, ss
                              mov                           real_sp, sp
                              mov                           real_ip, offset raw_mode_test_prot_return
                              mov                           real_cs, cs

                              mov                           ax, seg_real_ds
                              mov                           cx, seg_real_ds
                              mov                           dx, seg_real_ss
                              mov                           bx, offset stack_area_2
                              mov                           si, seg_real_cs
                              mov                           di, offset raw_mode_test_real_enter
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              jmp                     dword ptr raw_prot_switch

raw_mode_test_prot_return:
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              mov                           ax, es
                              mov                           ss, ax
                              mov                           di, sp
IFDEF TRACE
                              call                          machine_dump_with_ds
                              mov                           eax, dword ptr es:[00h+di]
                              mov                           ebx, dword ptr es:[04h+di]
                              mov                           ecx, dword ptr es:[08h+di]
                              mov                           edx, dword ptr es:[0ch+di]
                              call                          machine_dump_with_ds
                              mov                           eax, dword ptr es:[10h+di]
                              mov                           ebx, dword ptr es:[14h+di]
                              mov                           ecx, dword ptr es:[18h+di]
                              mov                           edx, dword ptr es:[1ch+di]
                              mov                           esi, dword ptr es:[20h+di]
                              call                          machine_dump_with_ds
ENDIF
                              mov                           al, 01h
                              call                    dword ptr raw_prot_save_restore

IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              add                           sp, raw_modees
                              pop                           es
                              popa
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              ret

raw_mode_test_real_enter:
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              pusha
                              push                          es
                              sub                           sp, raw_modees
                              mov                           di, sp
                              mov                           ax, ss
                              mov                           es, ax

IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              mov                           al, 00h
                              call                    dword ptr raw_real_save_restore

IFDEF TRACE
                              call                          machine_dump_with_ds
                              mov                           eax, dword ptr es:[00h+di]
                              mov                           ebx, dword ptr es:[04h+di]
                              mov                           ecx, dword ptr es:[08h+di]
                              mov                           edx, dword ptr es:[0ch+di]
                              call                          machine_dump_with_ds
                              mov                           eax, dword ptr es:[10h+di]
                              mov                           ebx, dword ptr es:[14h+di]
                              mov                           ecx, dword ptr es:[18h+di]
                              mov                           edx, dword ptr es:[1ch+di]
                              mov                           esi, dword ptr es:[20h+di]
                              call                          machine_dump_with_ds
ENDIF
                              mov                           ax, es
                              mov                           ss, ax
                              mov                           di, sp
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF

                              mov                           al, 01h
                              call                    dword ptr raw_real_save_restore

IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              add                           sp, raw_modees
                              pop                           es
                              popa
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              mov                           ax, real_ds
                              mov                           cx, real_ds
                              mov                           dx, real_ss
                              mov                           bx, real_sp
                              mov                           si, real_cs
                              mov                           di, real_ip
IFDEF TRACE
                              call                          machine_dump_with_ds
ENDIF
                              jmp                     dword ptr raw_real_switch

raw_mode_test                 endp

;====================================================================================================================================================;
;
; program_run - Runs one of the EXEs from the GAME, prepares the command string and the PSP, and issues interrupt 21 code 4B00
;
;====================================================================================================================================================;

program_run                   proc                          near
                              push                          bx
                              push                          cx
                              push                          dx
                              push                          ds
                              push                          si
                              push                          es
                              push                          di
                              push                          bp
                              mov                           bp, sp
                              sub                           sp, 0094h
                              push                          ss
                              pop                           es
                              mov                           di, sp
                              inc                           di
                              push                          di
                              mov                           ax, 007fh
                              mov                           cx, ax
                          rep movs                     byte ptr es:[di], byte ptr ds:[si]
                              xchg                          ax, cx
                              mov                           ah, cl
                              pop                           di
                        repne scas                     byte ptr es:[di]
                              inc                           cx
                              sub                           ah, cl
                              mov                           ss:[-94h+bp], ah          ; -94 argument size, -93..-15 argument
                              dec                           di
                              mov                           al, 0dh
                              stos                     byte ptr es:[di]
                              mov                           ss:[-0eh+bp], dx          ; -0e..-0d Environment Segment
                              mov                           ss:[-0ch+bp], sp          ; -0c..-09 Command Parameters
                              mov                           ss:[-0ah+bp], ss          ; bp - 0094 = sp
                              mov                      word ptr ss:[-08h+bp], 005ch   ; -08..-05 First  FCB
                              mov                           ss:[-06h+bp], es
                              mov                      word ptr ss:[-04h+bp], 006ch   ; -04..-01 Second FCB
                              mov                           ss:[-02h+bp], es
                              mov                           ah, 2fh
                              int                           21h
                              mov                           ss:[-14h+bp], bx          ; -14..-11 DTA
                              mov                           ss:[-12h+bp], es
                              mov                           ax, 3300h
                              int                           21h
                              mov                           ss:[-10h+bp], dl          ; -10 Flag Break
                              push                          bp
                              mov                           old_sp, sp
                              mov                           old_ss, ss
                              mov                           dx, ss:[02h+bp]           ; Argument : Program Name
                              mov                           ds, ss:[04h+bp]
                              mov                           bx, bp                    ; -0e Parameter Table
                              sub                           bx, 0eh
                              push                          ss
                              pop                           es
                              mov                           ax, 4b00h
                              int                           21h
                              xchg                          ax, bx                    ; bx <- return code
                              lahf
                              xchg                          ax, cx                    ; cx <- flags
                              mov                           dx, cs
                              mov                           ds, dx
                              cli
                              mov                           sp, old_sp
                              mov                           ss, old_ss
                              sti
                              pop                           bp
                              mov                           dl, ss:[-10h+bp]          ; Restore Flag Break
                              mov                           ax, 3301h
                              int                           21h
                              lds                           dx, ss:[-14h+bp]          ; Restore DTA
                              mov                           ah, 1ah
                              int                           21h
                              xchg                          ax, cx                    ; restore int 21/4b flags
                              sahf
                              xchg                          ax, bx                    ; restore int 21/4b return code
                              mov                           sp, bp
                              pop                           bp
                              pop                           di
                              pop                           es
                              pop                           si
                              pop                           ds
                              pop                           dx
                              pop                           cx
                              pop                           bx
                              ret
program_run                   endp

;====================================================================================================================================================;
;
; program_wait - Runs a GAME EXE with program_run above, Gets return code with interrupt 21 code 4d00
;
;====================================================================================================================================================;

program_wait                  proc                          near
                              push                          dx
                              xor                           dx, dx
                              mov                           interrupt_state, 01h
                              call                          program_run
                              mov                           interrupt_state, 0
                              jc                            program_wait_fail
                              mov                           ah, 4dh                   ; Obtain Application Code
                              int                           21h
program_wait_fail:
                              pop                           dx
                              ret
program_wait                  endp

IFDEF TRACE
;====================================================================================================================================================;
;
; machine_dump - Debugging help, writes all registers on a trace_file
;
;====================================================================================================================================================;

machine_dump                  proc                          near
occurrence_dump:
                              pushad
                              mov                           dx, offset trace_file
                              xor                           cx, cx
                              mov                           ax, 3d81h
                              int                           21h
                              jnc                           occurrence_dump_start
                              cmp                           ax, 0002h
                              jne                           occurrence_dump_fail
                              mov                           dx, offset trace_file
                              xor                           cx, cx
                              mov                           ah, 3ch
                              int                           21h
                              jc                            occurrence_dump_fail

occurrence_dump_start:
                              mov                           bx, ax
                              mov                           ax, 4202h
                              xor                           cx, cx
                              xor                           dx, dx
                              int                           21h
                              jc                            occurrence_dump_exit

occurrence_interrupt:
                              xor                           esi, esi
                              dec                           esi
                              mov                           dx, offset trace_interrupt_code
                              mov                           cx, offset trace_separ
                              call                          machine_dump_word_separ

                              mov                           esi, callback_global_occurrence
                              mov                           dx, offset trace_interrupt_occurs
                              mov                           cx, offset trace_line
                              call                          machine_dump_dword_separ

                              xor                           esi, esi
                              mov                           callback_global_occurrence, esi

occurrence_interrupt_loop:
                              mov                           ecx, 0100h
                              xor                           eax, eax
                              xor                           dx, dx
                              xor                           si, si
occurrence_interrupt_search:
                              cmp                           eax, callback_occurrence[si]
                              jae                           occurrence_interrupt_max
                              mov                           dx, si
                              mov                           eax, callback_occurrence[si]
occurrence_interrupt_max:
                              add                           si, 04h
                              loop                          occurrence_interrupt_search
                              or                            eax, eax
                              jz                            occurrence_location

                              mov                           si, dx
                              mov                           callback_occurrence[si], 00000000h

                              push                          eax
                              shr                           si, 02h
                              mov                           dx, offset trace_interrupt_code
                              mov                           cx, offset trace_separ
                              call                          machine_dump_word_separ

                              pop                           esi
                              mov                           dx, offset trace_interrupt_occurs
                              mov                           cx, offset trace_line
                              call                          machine_dump_dword_separ

                              jmp                           occurrence_interrupt_loop

occurrence_location:
occurrence_location_loop:
                              mov                           ecx, 0300h
                              xor                           eax, eax
                              xor                           dx, dx
                              xor                           si, si
occurrence_location_search:
                              cmp                           eax, callback_patchloc[04h+si]
                              jae                           occurrence_location_max
                              mov                           dx, si
                              mov                           eax, callback_patchloc[04h+si]
occurrence_location_max:
                              add                           si, 08h
                              loop                          occurrence_location_search
                              or                            eax, eax
                              jz                            occurrence_stacks

                              mov                           si, dx
                              mov                           callback_patchloc[04h+si], 00000000h

                              push                          eax
                              mov                           dx, word ptr callback_patchloc[02h+si]
                              sub                           dx, pgm_base
                              shl                           edx, 010h
                              mov                           dx, word ptr callback_patchloc[00h+si]
                              dec                           dx
                              mov                           esi, edx
                              mov                           dx, offset trace_interrupt_location
                              mov                           cx, offset trace_separ
                              call                          machine_dump_dword_separ

                              pop                           esi
                              mov                           dx, offset trace_interrupt_occurs
                              mov                           cx, offset trace_line
                              call                          machine_dump_dword_separ

                              jmp                           occurrence_location_loop

occurrence_stacks:
                              mov                           di, offset stack_area_1
                              mov                           cx, offset stack_area_2 - offset stack_area_1
                              mov                           al, 21h
                         repe scas                     byte ptr es:[di]
                              sub                           di, offset stack_area_1
                              mov                           si, di
                              mov                           dx, offset trace_stack_1
                              mov                           cx, offset trace_line
                              call                          machine_dump_word_separ

                              mov                           di, offset stack_area_2
                              mov                           cx, offset text_end - offset stack_area_2
                              mov                           al, 21h
                         repe scas                     byte ptr es:[di]
                              sub                           di, offset stack_area_2
                              mov                           si, di
                              mov                           dx, offset trace_stack_2
                              mov                           cx, offset trace_line
                              call                          machine_dump_word_separ

occurrence_dump_exit:
                              mov                           dx, offset trace_line
                              call                          separ_dump
                              mov                           ah, 3eh
                              int                           21h

occurrence_dump_fail:
                              popad
                              ret

machine_dump_real:
                              push                          esp
                              push                          ebp
                              movzx                         ebp, sp
                              push                          ds
                              push                          cs
                              pop                           ds
                              pushfd
                              pushad
                              jmp                           machine_dump_common

machine_dump_prot:
                              push                          esp
                              push                          ebp
                              movzx                         ebp, sp
                              push                          ds
                              mov                           ds, cs:seg_prot_ds
                              pushfd
                              pushad
                              jmp                           machine_dump_common

machine_dump_with_ds:
                              push                          esp
                              push                          ebp
                              movzx                         ebp, sp
                              push                          ds
                              pushfd
                              pushad

machine_dump_common:
                              mov                           dx, offset trace_file
                              xor                           cx, cx
                              mov                           ax, 3d81h
                              int                           21h
                              jnc                           machine_dump_start
                              cmp                           ax, 0002h
                              jne                           machine_dump_fail
                              mov                           dx, offset trace_file
                              xor                           cx, cx
                              mov                           ah, 3ch
                              int                           21h
                              jc                            machine_dump_fail

machine_dump_start:
                              mov                           bx, ax
                              mov                           ax, 4202h
                              xor                           cx, cx
                              xor                           dx, dx
                              int                           21h
                              jc                            machine_dump_exit

                              mov                           esi, dword ptr ss:[-0ah+ebp]
                              mov                           dx, offset trace_eax
                              mov                           cx, offset trace_separ
                              call                          machine_dump_dword_separ

                              mov                           esi, dword ptr ss:[-16h+ebp]
                              mov                           dx, offset trace_ebx
                              mov                           cx, offset trace_separ
                              call                          machine_dump_dword_separ

                              mov                           esi, dword ptr ss:[-0eh+ebp]
                              mov                           dx, offset trace_ecx
                              mov                           cx, offset trace_separ
                              call                          machine_dump_dword_separ

                              mov                           esi, dword ptr ss:[-12h+ebp]
                              mov                           dx, offset trace_edx
                              mov                           cx, offset trace_line
                              call                          machine_dump_dword_separ

                              mov                           esi, dword ptr ss:[-22h+ebp]
                              mov                           dx, offset trace_esi
                              mov                           cx, offset trace_separ
                              call                          machine_dump_dword_separ

                              mov                           esi, dword ptr ss:[-26h+ebp]
                              mov                           dx, offset trace_edi
                              mov                           cx, offset trace_separ
                              call                          machine_dump_dword_separ

                              mov                           esi, dword ptr ss:[+00h+ebp]
                              mov                           dx, offset trace_ebp
                              mov                           cx, offset trace_separ
                              call                          machine_dump_dword_separ

                              mov                           esi, dword ptr ss:[+04h+ebp]
                              mov                           dx, offset trace_esp
                              mov                           cx, offset trace_line
                              call                          machine_dump_dword_separ

                              mov                           si, word ptr ss:[-02h+ebp]
                              mov                           dx, offset trace_ds
                              mov                           cx, offset trace_separ
                              call                          machine_dump_seg_separ

                              mov                           si, es
                              mov                           dx, offset trace_es
                              mov                           cx, offset trace_separ
                              call                          machine_dump_seg_separ

                              mov                           si, cs
                              mov                           dx, offset trace_cs
                              mov                           cx, offset trace_separ
                              call                          machine_dump_seg_separ

                              mov                           si, word ptr ss:[+08h+ebp]
                              mov                           dx, offset trace_ip
                              mov                           cx, offset trace_separ
                              call                          machine_dump_word_separ

                              mov                           si, ss
                              mov                           dx, offset trace_ss
                              mov                           cx, offset trace_separ
                              call                          machine_dump_seg_separ

                              mov                           si, fs
                              mov                           dx, offset trace_fs
                              mov                           cx, offset trace_separ
                              call                          machine_dump_seg_separ

                              mov                           si, gs
                              mov                           dx, offset trace_gs
                              mov                           cx, offset trace_line
                              call                          machine_dump_seg_separ

                              mov                           cx, cs
                              cmp                           cx, seg_prot_cs
                              jne                           machine_dump_state

                              mov                           dx, gs
                              and                           dx, 0fff8h
                              mov                           cx, 00008h

machine_dump_ldt:
                              cmp                           cx, dx
                              ja                            machine_dump_state

                              push                          dx
                              push                          cx
                              mov                           si, cx
                              or                            si, 0007h

                              mov                           ax, cx
                              mov                           cx, offset trace_line
                              cmp                           ax, dx
                              mov                           dx, offset trace_rs
                              jz                            machine_dump_ldt_selector
                              test                          ax, 001fh
                              jz                            machine_dump_ldt_selector
                              mov                           cx, offset trace_separ

machine_dump_ldt_selector:
                              call                          machine_dump_seg_separ

                              pop                           cx
                              add                           cx, 0008h
                              pop                           dx
                              jmp                           machine_dump_ldt

machine_dump_state:
                              mov                           esi, dword ptr ss:[-06h+ebp]
                              mov                           dx, offset trace_eflags
                              mov                           cx, offset trace_separ
                              call                          machine_dump_dword_separ

                              mov                           esi, extra_data
                              mov                           dx, offset trace_extra
                              mov                           cx, offset trace_separ
                              call                          machine_dump_dword_separ

                              smsw                          si
                              mov                           dx, offset trace_sw
                              mov                           cx, offset trace_separ
                              call                          machine_dump_word_separ

                              mov                           dx, cs
                              cmp                           dx, seg_prot_cs
                              jne                           machine_dump_virtual

                              sldt                          si
                              mov                           dx, offset trace_lt
                              mov                           cx, offset trace_separ
                              call                          machine_dump_word_separ

                              str                           si
                              mov                           dx, offset trace_tr
                              mov                           cx, offset trace_separ
                              call                          machine_dump_word_separ

machine_dump_virtual:
                              sgdt                          pword ptr trace_descr
                              mov                           esi, dword ptr [02h+trace_descr]
                              mov                           dx, offset trace_gdt
                              call                          dword_dump
                              jc                            machine_dump_exit
                              mov                           si, word ptr [00h+trace_descr]
                              call                          word_dump_noheader
                              jc                            machine_dump_exit
                              mov                           dx, offset trace_separ
                              call                          separ_dump
                              jc                            machine_dump_exit

                              sidt                          pword ptr trace_descr
                              mov                           esi, dword ptr [02h+trace_descr]
                              mov                           dx, offset trace_idt
                              call                          dword_dump
                              jc                            machine_dump_exit
                              mov                           si, word ptr [00h+trace_descr]
                              call                          word_dump_noheader
                              jc                            machine_dump_exit
                              mov                           dx, offset trace_line
                              call                          separ_dump
                              jc                            machine_dump_exit
                              mov                           dx, offset trace_line
                              call                          separ_dump
                              jmp                           machine_dump_exit

machine_dump_call_exit:
                              pop                           ax
machine_dump_exit:
                              mov                           ah, 3eh
                              int                           21h
machine_dump_fail:
                              popad
                              popfd
                              pop                           ds
                              pop                           ebp
                              pop                           esp
                              ret

machine_dump_dword_separ:
                              push                          cx
                              call                          dword_dump
                              pop                           dx
                              jc                            machine_dump_call_exit
                              call                          separ_dump
                              jc                            machine_dump_call_exit
                              ret
machine_dump_word_separ:
                              push                          cx
                              call                          word_dump
                              pop                           dx
                              jc                            machine_dump_call_exit
                              call                          separ_dump
                              jc                            machine_dump_call_exit
                              ret

machine_dump_seg_separ:
                              push                          esi
                              push                          cx
                              call                          word_dump
                              pop                           dx
                              xor                           esi, esi
                              mov                     dword ptr [00h+trace_descr], esi
                              mov                     dword ptr [04h+trace_descr], esi
                              pop                           esi
                              jc                            machine_dump_call_exit
                              or                            si, si
                              jz                            machine_dump_seg_exit
                              mov                           cx, cs
                              cmp                           cx, seg_prot_cs
                              jne                           machine_dump_seg_exit
                              push                          dx
                              push                          bx
                              mov                           bx, si
                              push                          es
                              push                          ds
                              pop                           es
                              mov                           di, offset trace_descr
                              mov                           ax, 000bh
                              int                           31h
                              pop                           es
                              pop                           bx
                              mov                           esi, dword ptr [04h+trace_descr]
                              call                          dword_dump_noheader
                              pop                           dx
                              jc                            machine_dump_call_exit
                              push                          dx
                              mov                           esi, dword ptr [00h+trace_descr]
                              call                          dword_dump_noheader
                              pop                           dx
                              jc                            machine_dump_call_exit
machine_dump_seg_exit:
                              call                          separ_dump
                              jc                            machine_dump_call_exit
                              ret
machine_dump                  endp

;====================================================================================================================================================;
;
; dword_dump - Helper for machine_dump, equivalent to sprintf // %08lx
;
;====================================================================================================================================================;

dword_dump                    proc                          near
                              mov                           cx, 0003h
                              mov                           ah, 40h
                              int                           21h
dword_dump_noheader:
                              mov                           cx, 20h
                              mov                           di, offset trace_buffer
dword_dump_loop:
                              jcxz                          dword_dump_exit
                              sub                           cl, 04h
                              inc                           di
                              mov                           eax, esi
                              shr                           eax, cl
                              and                           al, 0fh
                              add                           al, 30h
                              cmp                           al, 3ah
                              jl                            dword_dump_1
                              add                           al, 07h
dword_dump_1:
                              mov                           ds:[02h+di], al
                              jmp                           dword_dump_loop
dword_dump_exit:
                              mov                           cx, 0bh
                              mov                           dx, offset trace_buffer
                              mov                           ah, 40h
                              int                           21h
                              ret
dword_dump                    endp

;====================================================================================================================================================;
;
; word_dump - Helper for machine_dump, equivalent to sprintf // %04x
;
;====================================================================================================================================================;

word_dump                     proc                          near
                              mov                           cx, 0002h
                              mov                           ah, 40h
                              int                           21h
word_dump_noheader:
                              mov                           cx, 10h
                              mov                           di, offset trace_buffer
word_dump_loop:
                              jcxz                          word_dump_exit
                              sub                           cl, 04h
                              inc                           di
                              mov                           ax, si
                              shr                           ax, cl
                              and                           al, 0fh
                              add                           al, 30h
                              cmp                           al, 3ah
                              jl                            word_dump_1
                              add                           al, 07h
word_dump_1:
                              mov                           ds:[02h+di], al
                              jmp                           word_dump_loop
word_dump_exit:
                              mov                           cx, 07h
                              mov                           dx, offset trace_buffer
                              mov                           ah, 40h
                              int                           21h
                              ret
word_dump                     endp

;====================================================================================================================================================;
;
; separ_dump - Helper for machine_dump, equivalent to sprintf // %2.2s
;
;====================================================================================================================================================;

separ_dump                    proc                          near
                              mov                           cx, 0002h
                              mov                           ah, 40h
                              int                           21h
                              ret
separ_dump                    endp
ENDIF

;====================================================================================================================================================;
;                             H O O K                       C O D E
;====================================================================================================================================================;

                              assume                        cs:text, ds:nothing

;====================================================================================================================================================;
;
; interrupt_21 - Traps an Open on EMMXXXX0, then answers not found, passes through all other requests
;
;====================================================================================================================================================;

interrupt_21                  proc                          near
                              pushf
                              push                          bx
                              cmp                           interrupt_state, 0
                              je                            interrupt_21_propagate
                              cmp                           ah, 3dh
                              jne                           interrupt_21_propagate
                              mov                           bx,dx
                              cmp                     dword ptr ds:[00h+bx], 584d4d45h
                              jne                           interrupt_21_propagate
                              cmp                     dword ptr ds:[04h+bx], 30585858h
                              jne                           interrupt_21_propagate
                              push                          bp
                              mov                           bp, sp
                              push                          eax
                              mov                           eax, dword ptr ss:[06h+bp]
IFDEF TRACE
                              mov                           extra_data, eax
ENDIF
                              or                       byte ptr ss:[0ah+bp], 01h
                              pop                           eax
                              pop                           bp
                              pop                           bx
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump_real
                              mov                           interrupt_state, 01h
ENDIF
                              popf
                              mov                           al,02h
                              iret

interrupt_21_propagate:
                              pop                           bx
                              popf
                              jmp                     dword ptr cs:[int_21]
interrupt_21                  endp

;====================================================================================================================================================;
;
; interrupt_2f - Traps on Locate XMS, passes through all other requests
;
;====================================================================================================================================================;

interrupt_2f                  proc                          near
                              push                          es
                              pushf
                              cmp                           interrupt_state, 00h
                              je                            interrupt_2f_propagate
                              cmp                           ax, 4310h
                              jne                           interrupt_2f_propagate
IFDEF TRACE
                              push                          bp
                              mov                           bp, sp
                              push                          eax
                              mov                           eax, dword ptr ss:[06h+bp]
                              mov                           extra_data, eax
                              pop                           eax
                              pop                           bp
                              mov                           interrupt_state, 00h
                              call                          machine_dump_real
                              mov                           interrupt_state, 01h
ENDIF
                              call                    dword ptr cs:[int_2f]
                              mov                      word ptr [00h+xms_hd], bx
                              mov                      word ptr [02h+xms_hd], es
                              pop                           es
                              push                          cs
                              pop                           es
                              mov                           bx, offset xms_handler
                              iret

interrupt_2f_propagate:
                              popf
                              pop                           es
                              jmp                     dword ptr cs:[int_2f]
interrupt_2f                  endp

;====================================================================================================================================================;
;
; xms_handler - Service given as XMS Routine, traps on Allocate 0900, Free 0a00, Lock 0c00, Unlock 0d00
;               Upon Allocate, sends the memory  request to the DPMI code for Memory Allocate
;               Upon Free,     sends the memory  request to the DPMI code for Memory Free
;               Upon Lock,     patches the EXE
;               Upon Unlock,   does nothing further
;
;====================================================================================================================================================;

xms_handler                   proc                          near
                              cmp                           interrupt_state, 00h
                              je                            xms_handler_propagate
IFDEF TRACE
                              cmp                           ah, 08h
                              je                            xms_handler_capture
                              cmp                           ah, 09h
                              je                            xms_handler_capture
                              cmp                           ah, 0ah
                              je                            xms_handler_capture
                              cmp                           ah, 0ch
                              je                            xms_handler_capture
                              cmp                           ah, 0dh
                              jne                           xms_handler_propagate
xms_handler_capture:
                              push                          bp
                              mov                           bp, sp
                              push                          eax
                              mov                           eax, dword ptr ss:[02h+bp]
                              mov                           extra_data, eax
                              pop                           eax
                              pop                           bp
                              mov                           interrupt_state, 00h
                              call                          machine_dump_real
                              mov                           interrupt_state, 01h
ENDIF
                              cmp                           ah, 08h
                              je                            xms_handler_capture_08
                              cmp                           ah, 09h
                              je                            xms_handler_capture_09
                              cmp                           ah, 0ah
                              je                            xms_handler_capture_0a
                              cmp                           ah, 0ch
                              je                            xms_handler_capture_0c
                              cmp                           ah, 0dh
                              je                            xms_handler_capture_0d
                              jmp                           xms_handler_propagate

xms_handler_capture_08:
                              mov                           ax, 0400h
                              mov                           dx, 0400h
                              retf

xms_handler_capture_09:
                              mov                           bx, offset dpmi_block_00
                              cmp                      byte ptr cs:[00h+bx], 00h
                              je                            xms_handler_09_found
                              mov                           bx, offset dpmi_block_01
                              cmp                      byte ptr cs:[00h+bx], 00h
                              je                            xms_handler_09_found
                              mov                           bx, offset dpmi_block_02
                              cmp                      byte ptr cs:[00h+bx], 00h
                              je                            xms_handler_09_found
                              mov                           bx, offset dpmi_block_03
                              cmp                      byte ptr cs:[00h+bx], 00h
                              je                            xms_handler_09_found
xms_handler_09_fail:
                              mov                           bl, 0a0h
                              xor                           ax, ax
                              retf

xms_handler_09_found:
                              push                          bx
                              mov                           cx, dx
                              xor                           bx, bx
                              shld                          bx, cx, 0ah
                              shl                           cx, 0ah
                              mov                           ax, 0501h
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump_real
                              mov                           interrupt_state, 01h
ENDIF
                              db                            0cch, 00h
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump_real
                              mov                           interrupt_state, 01h
ENDIF
                              pop                           dx
                              jc                            xms_handler_09_fail
                              xchg                          dx, bx
                              mov                      byte ptr cs:[00h+bx], 01h
                              mov                      word ptr cs:[01h+bx], cx
                              mov                      word ptr cs:[03h+bx], dx
                              mov                      word ptr cs:[05h+bx], di
                              mov                      word ptr cs:[07h+bx], si
                              xchg                          dx, bx
                              mov                           ax, 0001h
                              retf

xms_handler_capture_0a:
                              push                          dx
                              xchg                          dx, bx
                              mov                           di, word ptr cs:[05h+bx]
                              mov                           si, word ptr cs:[07h+bx]
                              xchg                          dx, bx
                              mov                           ax, 0502h
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump_real
                              mov                           interrupt_state, 01h
ENDIF
                              db                            0cch, 00h
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump_real
                              mov                           interrupt_state, 01h
ENDIF
                              pop                           dx
                              jc                            xms_handler_0a_fail
                              xchg                          dx, bx
                              mov                      byte ptr cs:[00h+bx], 00h
                              xchg                          dx, bx
                              mov                           ax, 0001h
                              retf
xms_handler_0a_fail:
                              mov                           bl, 0a2h
                              xor                           ax, ax
                              retf

xms_handler_capture_0c:
                              push                          si
                              push                          es
                              push                          bx
                              push                          dx
xms_handler_patch_u71:
                              test                          is_u72, 01h
                              jnz                           xms_handler_patch_u72
xms_handler_patch_main_u71:
                              cmp                           executable_state, 01h
                              jne                           xms_handler_patch_game_u71
                              mov                           bx, offset u71_main_patch
                              jmp                           xms_handler_patch_start
xms_handler_patch_game_u71:
                              cmp                           executable_state, 03h
                              jne                           xms_handler_patch_end_u71
                              mov                           bx, offset u71_game_patch
                              jmp                           xms_handler_patch_start
xms_handler_patch_end_u71:
                              cmp                           executable_state, 04h
                              jne                           xms_handler_patch_end
                              mov                           bx, offset u71_end_patch
                              jmp                           xms_handler_patch_start

xms_handler_patch_u72:
xms_handler_patch_int_u72:
                              cmp                           executable_state, 02h
                              jne                           xms_handler_patch_main_u72
                              mov                           bx, offset u72_int_patch
                              jmp                           xms_handler_patch_start
xms_handler_patch_main_u72:
                              cmp                           executable_state, 01h
                              jne                           xms_handler_patch_game_u72
                              mov                           bx, offset u72_main_patch
                              jmp                           xms_handler_patch_start
xms_handler_patch_game_u72:
                              cmp                           executable_state, 03h
                              jne                           xms_handler_patch_end_u72
                              mov                           bx, offset u72_game_patch
                              jmp                           xms_handler_patch_start
xms_handler_patch_end_u72:
                              cmp                           executable_state, 04h
                              jne                           xms_handler_patch_end
                              mov                           bx, offset u72_end_patch
                              jmp                           xms_handler_patch_start

xms_handler_patch_start:
                              mov                           si, ss
                              sub                           si, word ptr cs:[bx]
                              mov                           pgm_base, si
                              inc                           bx
                              inc                           bx
IFDEF TRACE
                              mov                           dx, offset callback_patchloc
ENDIF
xms_handler_patch_loop:
                              mov                           si, word ptr cs:[bx]
                              or                            si, si
                              jz                            xms_handler_patch_end
                              js                            xms_handler_patch_ds
                              cmp                      byte ptr es:[si], 0cch
                              je                            xms_handler_patch_end


IFDEF TRACE
                              push                          di
                              mov                           di, si
                              inc                           di
                              xchg                          bx, dx
                              mov                      word ptr cs:[00h+bx], di
                              mov                      word ptr cs:[02h+bx], es
                              mov                     dword ptr cs:[04h+bx], 00000000h
                              xchg                          bx, dx
                              add                           dx, 0008h
                              push                          eax
                              mov                           eax, dword ptr es:[si]
                              mov                           extra_data, eax
                              pop                           eax
                              push                          si
                              mov                           interrupt_state, 00h
                              call                          machine_dump_real
                              mov                           interrupt_state, 01h
ENDIF
                              call                          interrupt_insert
                              jc                            xms_handler_patch_error
IFDEF TRACE
                              pop                           di
                              push                          eax
                              mov                           eax, dword ptr es:[di]
                              mov                           extra_data, eax
                              pop                           eax
                              pop                           di
                              mov                           interrupt_state, 00h
                              call                          machine_dump_real
                              mov                           interrupt_state, 01h
ENDIF
                              inc                           bx
                              inc                           bx
                              jmp                           xms_handler_patch_loop

xms_handler_patch_ds:
                              mov                           si, ss
                              add                           si, word ptr cs:[bx]
                              mov                           es, si
                              inc                           bx
                              inc                           bx
                              jmp                           xms_handler_patch_loop

xms_handler_patch_end:
IFDEF TEST_FIXSIINTRO
                              test                          is_u72, 01h
                              jz                            xms_handler_patch_leave
                              cmp                           executable_state, 02h
                              jne                           xms_handler_patch_leave
                              mov                           bx, pgm_base
                              mov                           es, bx
                              mov                      byte ptr es:[395bh], 0c3h
xms_handler_patch_leave:
ENDIF
                              pop                           dx
                              pop                           bx
                              pop                           es
                              pop                           si

                              xchg                          dx, bx
                              mov                           dx, word ptr cs:[03h+bx]
                              mov                           bx, word ptr cs:[01h+bx]
                              mov                           ax, 0001h
                              retf

xms_handler_patch_error:
                              pop                           dx
                              pop                           bx
                              pop                           es
                              pop                           si

                              xchg                          dx, bx
                              mov                           ax, 0000h
                              retf

xms_handler_capture_0d:
                              mov                           ax, 0001h
                              retf

xms_handler_propagate:
                              jmp                     dword ptr cs:[xms_hd]
xms_handler                   endp

;====================================================================================================================================================;
;
; The Heart of U7DPMI, the VOODOO instruction patcher
;
;====================================================================================================================================================;

interrupt_insert              proc                          near
;                             Address 32 [67h] prefix is always assumed
;                             Format Special for Int 31       is  0000 0000
;                             Format 0 Code (for non strings) is  000b bbcd (with cd <> 00)
;                              where d = 1 Data    32 (66h prefix)
;                              where c = 1 ES:        (26h prefix) for not strings
;                              where b bb = 0 00 The instruction proper is 2 bytes
;                              where b bb = 0 01 The instruction proper is 3 bytes
;                              where b bb = 0 10 The instruction proper is 4 bytes
;                              where b bb = 0 11 The instruction proper is 5 bytes
;                              where b bb = 1 00 The instruction proper is 6 bytes
;                              where b bb = 1 01 The instruction proper is 7 bytes
;                              where b bb = 1 10 The instruction proper is 8 bytes
;                              where b bb = 1 11 The instruction proper is 9 bytes
;                              the codop byte is never missing (cd <> 0 implies 2+ prefix bytes)
;                             Format 1 Code (for strings)     is  01aa aacd
;                              where d = 1 Data    32 (66h prefix)
;                              where c = 1 REP        (f3h prefix) for strings
;                              the instruction proper is always 1 byte
;                              where aa aa = 00 00 a4 MovsB
;                              where aa aa = 00 01 a5 MovsW
;                              where aa aa = 00 10 a6 CmpsB
;                              where aa aa = 00 11 a7 CmpsW
;                              where aa aa = 01 00 aa StosB
;                              where aa aa = 01 01 ab StosW
;                              where aa aa = 01 10 ac LodsB
;                              where aa aa = 01 11 ad LodsW
;                              where aa aa = 10 00 ae ScasB
;                              where aa aa = 10 01 af ScasW
;                              where aa aa = 10 10 d7 Xlat
;                             Format 2 Code (for non strings) is  1aab bbaa (no other prefix than 67h, codop overwritten)
;                              where b bb = 0 00 The instruction proper is 2 bytes
;                              where b bb = 0 01 The instruction proper is 3 bytes
;                              where b bb = 0 10 The instruction proper is 4 bytes
;                              where b bb = 0 11 The instruction proper is 5 bytes
;                              where b bb = 1 00 The instruction proper is 6 bytes
;                              where b bb = 1 01 The instruction proper is 7 bytes
;                              where b bb = 1 10 The instruction proper is 8 bytes
;                              where b bb = 1 11 The instruction proper is 9 bytes
;                              where aa aa = 00 00 Codop Byte is 88 Mov  Eb,Gb (67h only prefix)
;                              where aa aa = 00 01 Codop Byte is 89 Mov  Ev,Gv (67h only prefix)
;                              where aa aa = 00 10 Codop Byte is 8a Mov  Gb,Eb (67h only prefix)
;                              where aa aa = 00 11 Codop Byte is 8b Mov  Gv,Ev (67h only prefix)
;                              where aa aa = 01 00 Codop Byte is 03 Add  Gv,Ev (67h only prefix)
;                              where aa aa = 01 01 Codop Byte is 13 Adc  Gv,Ev (67h only prefix)
;                              where aa aa = 01 10 Codop Byte is 2b Sub  Gv,Ev (67h only prefix)
;                              where aa aa = 01 11 Codop Byte is 0b Or   Gv,Ev (67h only prefix)
;                              where aa aa = 10 00 Codop Byte is c7 Mov  Gv,Iv (67h only prefix)
;                              where aa aa = 10 01 Codop Byte is f7 Test Gv,Iv (67h only prefix)
;                              where aa aa = 11 00 Codop Byte is 38 Cmp  Eb,Gb (67h only prefix)
;                              where aa aa = 11 01 Codop Byte is 39 Cmp  Ev,Gv (67h only prefix)
;                              where aa aa = 11 10 Codop Byte is 3a Cmp  Gb,Gb (67h only prefix)
;                              where aa aa = 11 11 Codop Byte is 3b Cmp  Gv,Ev (67h only prefix)
                              push                          ds
                              push                          es
                              pop                           ds
                              push                          di
                              push                          ax
                              push                          bx
                              push                          dx
                              xor                           dx, dx
                              push                          si
                              lods                     byte ptr ds:[si]
interrupt_insert_rep:
                              cmp                           al, 0f3h
                              jne                           interrupt_insert_reg32
                              or                            dl, 02h
                              lods                     byte ptr ds:[si]
interrupt_insert_reg32:
                              cmp                           al, 066h
                              jne                           interrupt_insert_es
                              or                            dl, 01h
                              lods                     byte ptr ds:[si]
interrupt_insert_es:
                              cmp                           al, 026h
                              jne                           interrupt_insert_adr32
                              test                          dl, 02h
                              jnz                           interrupt_insert_none
                              or                            dl, 02h
                              lods                     byte ptr ds:[si]
interrupt_insert_adr32:
                              cmp                           al, 067h
                              jne                           interrupt_insert_none
                              lods                     byte ptr ds:[si]
interrupt_insert_string_1:
                              cmp                           al, 0a4h
                              jb                            interrupt_insert_size
                              cmp                           al, 0a7h
                              ja                            interrupt_insert_string_2
                              sub                           al, 094h
                              shl                           al, 02
                              jmp                           interrupt_insert_common
interrupt_insert_string_2:
                              cmp                           al, 0aah
                              jb                            interrupt_insert_size
                              cmp                           al, 0afh
                              ja                            interrupt_insert_string_3
                              sub                           al, 096h
                              shl                           al, 02
                              jmp                           interrupt_insert_common
interrupt_insert_string_3:
                              cmp                           al, 0d7h
                              jne                           interrupt_insert_size
                              mov                           al, 068h
                              jmp                           interrupt_insert_common
interrupt_insert_size:
                              mov                           ah, al
                              lods                     byte ptr ds:[si]
                              mov                           bh, al
                              and                           al, 0c7h
                              cmp                           al, 0c0h
                              jae                           interrupt_insert_computed
                              cmp                           al, 004h
                              je                            interrupt_insert_extra_byte
                              cmp                           al, 044h
                              je                            interrupt_insert_extra_byte
                              cmp                           al, 084h
                              jne                           interrupt_insert_modrm
interrupt_insert_extra_byte:
                              lods                     byte ptr ds:[si]
                              mov                           bl, al
                              and                           al, 007h
                              and                           bh, 0c0h
                              or                            al, bh
                              inc                           dh
interrupt_insert_modrm:
                              cmp                           al, 005h
                              je                            interrupt_insert_add_4
                              cmp                           al, 040h
                              jb                            interrupt_insert_computed
                              cmp                           al, 080h
                              jb                            interrupt_insert_add_1
interrupt_insert_add_4:
                              lods                     byte ptr ds:[si]
                              inc                           dh
                              lods                     byte ptr ds:[si]
                              inc                           dh
                              lods                     byte ptr ds:[si]
                              inc                           dh
interrupt_insert_add_1:
                              lods                     byte ptr ds:[si]
                              inc                           dh
interrupt_insert_computed:
                              cmp                           dh, 007h
                              ja                            interrupt_insert_none
                              or                            dl, dl
                              jz                            interrupt_insert_short
interrupt_insert_long:
                              mov                           al, dl
                              shr                           dx, 06h
                              jmp                           interrupt_insert_common
interrupt_insert_short:
                              shr                           dx, 06h
                              mov                           al, 080h
                              cmp                           ah, 088h
                              je                            interrupt_insert_common
                              mov                           al, 081h
                              cmp                           ah, 089h
                              je                            interrupt_insert_common
                              mov                           al, 082h
                              cmp                           ah, 08ah
                              je                            interrupt_insert_common
                              mov                           al, 083h
                              cmp                           ah, 08bh
                              je                            interrupt_insert_common
                              mov                           al, 0a0h
                              cmp                           ah, 003h
                              je                            interrupt_insert_common
                              mov                           al, 0a1h
                              cmp                           ah, 013h
                              je                            interrupt_insert_common
                              mov                           al, 0a2h
                              cmp                           ah, 02bh
                              je                            interrupt_insert_common
                              mov                           al, 0a3h
                              cmp                           ah, 00bh
                              je                            interrupt_insert_common
                              mov                           al, 0e0h
                              cmp                           ah, 038h
                              je                            interrupt_insert_common
                              mov                           al, 0e1h
                              cmp                           ah, 039h
                              je                            interrupt_insert_common
                              mov                           al, 0e2h
                              cmp                           ah, 03ah
                              je                            interrupt_insert_common
                              mov                           al, 0e3h
                              cmp                           ah, 03bh
                              je                            interrupt_insert_common
                              add                           dl, 08h
                              mov                           al, 0c0h
                              cmp                           ah, 0c7h
                              je                            interrupt_insert_common
                              mov                           al, 0c1h
                              cmp                           ah, 0f7h
                              je                            interrupt_insert_common
                              jmp                           interrupt_insert_none
interrupt_insert_common:
                              pop                           di
                              or                            dl, al
                              mov                           al, 0cch
                              stos                     byte ptr es:[di]
                              mov                           al, dl
                              stos                     byte ptr es:[di]
                              pop                           dx
                              pop                           bx
                              pop                           ax
                              pop                           di
                              pop                           ds
                              clc
                              ret
interrupt_insert_none:
                              pop                           dx
                              pop                           dx
                              pop                           ax
                              pop                           di
                              pop                           ds
                              stc
                              ret
interrupt_insert              endp

;====================================================================================================================================================;
;
; The Heart of U7DPMI, the VOODOO instruction interpreter
;
;====================================================================================================================================================;

callback_proc                 proc                          near
;
;                                  When I arrive here, Interrupts are disabled, Mode is protected,
;                                  DS:SI          selector:offset to real mode SS:SP
;                                                 since these Borland EXE Programs use DS=SS, access to EXE DS
;                                  ES:DI          selector:offset to register data structure
;                                                 since the one provided by 0303h call, access to COM DS/ES/SS
;                                  SS:SP          selector:offset to private DPMI provided stack
;                                  CS:IP          selector:offset to callback routine
;                                                 since the one provided by 0303h call, access to COM CS
; ic = 0058, occ = 0001B4B6        LODSB
; ic = 0052, occ = 0000B9D3    REP STOSB
; ic = 0057, occ = 0000B9D3    REP STOSD
; ic = 005C, occ = 0000AE3A        LODSW
; ic = 0042, occ = 0000A33B    REP MOVSB
; ic = 0047, occ = 0000A33B    REP MOVSD
; ic = 0001, occ = 0000760A    66/REG32 67/ADR32 XX YY
; ic = 00C4, occ = 00000977        SUB Gw, Ew 67/ADR32 XX YY ZZ
; ic = 0085, occ = 000004F5        MOV Gw, Ew 67/ADR32 XX YY ZZ
; ic = 0081, occ = 000004BC        MOV Gw, Ew 67/ADR32 XX YY
; ic = 0005, occ = 000003FB    66/REG32 67/ADR32 XX YY ZZ
; ic = 00E5, occ = 000003FB        CMP Gw, Ew 67/ADR32 XX YY ZZ
; ic = 0055, occ = 00000190        STOSD
; ic = 00E4, occ = 000000C1        CMP Ew, Gw 67/ADR32 XX YY ZZ
; ic = 0000, occ = 00000004        INT 31
                              xor                           ebx, ebx
                              xor                           eax, eax
                              lods                     word ptr ds:[si]
                              xchg                          bx, ax
                              mov                           es:real_ip, bx
                              lods                     word ptr ds:[si]
                              mov                           es:real_cs, ax
IFDEF TRACE
                              mov                           dx, offset callback_patchloc
                              xchg                          ebx, edx
callback_loc_search:
                              cmp                           ax, word ptr es:[02h+bx]
                              jl                            callback_loc_exit
                              jne                           callback_loc_next
                              cmp                           dx, word ptr es:[00h+bx]
                              jl                            callback_loc_exit
                              jne                           callback_loc_next
                              inc                     dword ptr es:[04h+bx]
                              jmp                           callback_loc_exit
callback_loc_next:
                              add                           bx, 008h
                              jmp                           callback_loc_search
callback_loc_exit:
                              xchg                          ebx, edx
ENDIF
                              shl                           eax, 04h
                              add                           ebx, eax
                              mov                           fs, es:big_selector
                              mov                           al, byte ptr fs:[ebx]
                              mov                           es:type_call, al
                              lods                     word ptr ds:[si]
                              mov                           es:real_flags, ax
                              mov                           ax, es:real_sp
                              add                           ax, 0006h
                              mov                           es:real_sp, ax
IFDEF TRACE
                              push                          bx
                              movzx                         bx, es:type_call
                              shl                           bx, 02h
                              inc                     dword ptr es:callback_global_occurrence
                              inc                     dword ptr es:[bx+callback_occurrence]
                              pop                           bx
ENDIF
                              push                          di
IFDEF TEST_FIXSISHAPE
                              cmp                      word ptr es:real_ip, 12b9h
                              jne                           callback_build_normal
                              test                          es:is_u72, 01h
                              jz                            callback_build_normal
                              cmp                           es:executable_state, 03h
                              jne                           callback_build_normal
                              test                     byte ptr es:real_esi+3, 080h
                              jz                            callback_build_normal
                              test                     byte ptr es:real_ebx+3, 0ffh
                              jnz                           callback_build_bugshape
                              mov                           eax, es:real_esi
                              add                           eax, es:real_ebx
                              test                     byte ptr fs:[eax+07h], 0ffh
                              jz                            callback_build_normal
callback_build_bugshape:
                              mov                      word ptr es:real_ip, 12c0h
                              pop                           di
                              iret
ENDIF
callback_build_normal:
                              mov                           ah, es:type_call
                              or                            ah, ah
                              jne                           callback_build_format
                              inc                           es:real_ip
                              jmp                           callback_load_machine

callback_build_format:
                              mov                           di, offset callback_type_run
callback_build_format_0:
                              cmp                           ah, 040h
                              jae                           callback_build_format_1
                              test                          ah, 01h
                              jz                            callback_build_format_0_1
                              mov                           al, 066h
                              stos                     byte ptr es:[di]
                              inc                           ebx
                              inc                           es:real_ip
callback_build_format_0_1:
                              test                          ah, 02h
                              jz                            callback_build_format_0_2
                              mov                           al, 026h
                              stos                     byte ptr es:[di]
                              inc                           ebx
                              inc                           es:real_ip
callback_build_format_0_2:
                              mov                           al, 067h
                              stos                     byte ptr es:[di]
                              mov                           ch, ah
                              shr                           cx, 0ah
                              inc                           cx
callback_build_format_bytes:
                              inc                           cx
callback_build_format_0_3:
                              mov                           al, byte ptr fs:[ebx]
                              inc                           ebx
                              inc                           es:real_ip
                              stos                     byte ptr es:[di]
                              loop                          callback_build_format_0_3
callback_build_format_end:
                              mov                           al, 0ebh
                              stos                     byte ptr es:[di]
                              mov                           ax, offset callback_type_segregs
                              sub                           ax, di
                              dec                           ax
                              stos                     byte ptr es:[di]
                              jmp                           callback_load_machine

callback_build_format_1:
                              cmp                           ah, 080h
                              jae                           callback_build_format_2
                              movzx                         bx, es:type_call
                              shl                           bx, 01h
                              jmp                      word ptr es:[callback_vector-0080h+bx]
callback_vector:
                              dw                            offset callback_fast_0040
                              dw                            01h dup(offset callback_build_format_1_0)
                              dw                            offset callback_fast_0042
                              dw                            01h dup(offset callback_build_format_1_0)
                              dw                            offset callback_fast_0044
                              dw                            offset callback_fast_0045
                              dw                            offset callback_fast_0046
                              dw                            offset callback_fast_0047
                              dw                            08h dup(offset callback_build_format_1_0)
                              dw                            offset callback_fast_0050
                              dw                            01h dup(offset callback_build_format_1_0)
                              dw                            offset callback_fast_0052
                              dw                            01h dup(offset callback_build_format_1_0)
                              dw                            offset callback_fast_0054
                              dw                            offset callback_fast_0055
                              dw                            offset callback_fast_0056
                              dw                            offset callback_fast_0057
                              dw                            offset callback_fast_0058
                              dw                            03h dup(offset callback_build_format_1_0)
                              dw                            offset callback_fast_005C
                              dw                            offset callback_fast_005D
                              dw                            02h dup(offset callback_build_format_1_0)
                              dw                            08h dup(offset callback_build_format_1_0)
                              dw                            offset callback_fast_0068
                              dw                            07h dup(offset callback_build_format_1_0)
                              dw                            10h dup(offset callback_build_format_1_0)
callback_fast_0040:
                              push                          es
                              movzx                         eax, es:real_ds
                              movzx                         edx, es:real_es
                              shl                           eax, 4
                              shl                           edx, 4
                              mov                           esi, es:real_esi
                              mov                           edi, es:real_edi
                              add                           esi, eax
                              add                           edi, edx
                              mov                           ds, es:big_selector
                              mov                           es, es:big_selector
                              movs                     byte ptr es:[edi], byte ptr ds:[esi]
                              pop                           es
                              sub                           esi, eax
                              sub                           edi, edx
                              mov                           es:real_esi, esi
                              mov                           es:real_edi, edi
                              inc                           es:real_ip
                              pop                           di
                              iret
callback_fast_0042:
                              push                          es
                              movzx                         eax, es:real_ds
                              movzx                         edx, es:real_es
                              shl                           eax, 4
                              shl                           edx, 4
                              mov                           esi, es:real_esi
                              mov                           edi, es:real_edi
                              add                           esi, eax
                              add                           edi, edx
                              mov                           cx, word ptr es:real_ecx
                              mov                           ds, es:big_selector
                              mov                           es, es:big_selector
                          rep movs                     byte ptr es:[edi], byte ptr ds:[esi]
                              pop                           es
                              sub                           esi, eax
                              sub                           edi, edx
                              mov                           es:real_esi, esi
                              mov                           es:real_edi, edi
                              mov                      word ptr es:real_ecx, cx
                              inc                           es:real_ip
                              inc                           es:real_ip
                              pop                           di
                              iret
callback_fast_0044:
                              push                          es
                              movzx                         eax, es:real_ds
                              movzx                         edx, es:real_es
                              shl                           eax, 4
                              shl                           edx, 4
                              mov                           esi, es:real_esi
                              mov                           edi, es:real_edi
                              add                           esi, eax
                              add                           edi, edx
                              mov                           ds, es:big_selector
                              mov                           es, es:big_selector
                              movs                     word ptr es:[edi], word ptr ds:[esi]
                              pop                           es
                              sub                           esi, eax
                              sub                           edi, edx
                              mov                           es:real_esi, esi
                              mov                           es:real_edi, edi
                              inc                           es:real_ip
                              pop                           di
                              iret
callback_fast_0045:
                              push                          es
                              movzx                         eax, es:real_ds
                              movzx                         edx, es:real_es
                              shl                           eax, 4
                              shl                           edx, 4
                              mov                           esi, es:real_esi
                              mov                           edi, es:real_edi
                              add                           esi, eax
                              add                           edi, edx
                              mov                           ds, es:big_selector
                              mov                           es, es:big_selector
                              movs                    dword ptr es:[edi], dword ptr ds:[esi]
                              pop                           es
                              sub                           esi, eax
                              sub                           edi, edx
                              mov                           es:real_esi, esi
                              mov                           es:real_edi, edi
                              inc                           es:real_ip
                              inc                           es:real_ip
                              pop                           di
                              iret
callback_fast_0046:
                              push                          es
                              movzx                         eax, es:real_ds
                              movzx                         edx, es:real_es
                              shl                           eax, 4
                              shl                           edx, 4
                              mov                           esi, es:real_esi
                              mov                           edi, es:real_edi
                              add                           esi, eax
                              add                           edi, edx
                              mov                           cx, word ptr es:real_ecx
                              mov                           ds, es:big_selector
                              mov                           es, es:big_selector
                          rep movs                     word ptr es:[edi], word ptr ds:[esi]
                              pop                           es
                              sub                           esi, eax
                              sub                           edi, edx
                              mov                           es:real_esi, esi
                              mov                           es:real_edi, edi
                              mov                      word ptr es:real_ecx, cx
                              inc                           es:real_ip
                              inc                           es:real_ip
                              pop                           di
                              iret
callback_fast_0047:
                              push                          es
                              movzx                         eax, es:real_ds
                              movzx                         edx, es:real_es
                              shl                           eax, 4
                              shl                           edx, 4
                              mov                           esi, es:real_esi
                              mov                           edi, es:real_edi
                              add                           esi, eax
                              add                           edi, edx
                              mov                           cx, word ptr es:real_ecx
                              mov                           ds, es:big_selector
                              mov                           es, es:big_selector
                          rep movs                    dword ptr es:[edi], dword ptr ds:[esi]
                              pop                           es
                              sub                           esi, eax
                              sub                           edi, edx
                              mov                           es:real_esi, esi
                              mov                           es:real_edi, edi
                              mov                      word ptr es:real_ecx, cx
                              inc                           es:real_ip
                              inc                           es:real_ip
                              inc                           es:real_ip
                              pop                           di
                              iret
callback_fast_0050:
                              push                          es
                              movzx                         edx, es:real_es
                              shl                           edx, 4
                              mov                           edi, es:real_edi
                              add                           edi, edx
                              mov                           al, byte ptr es:real_eax
                              mov                           es, es:big_selector
                              stos                     byte ptr es:[edi]
                              pop                           es
                              sub                           edi, edx
                              mov                           es:real_edi, edi
                              inc                           es:real_ip
                              pop                           di
                              iret
callback_fast_0052:
                              push                          es
                              movzx                         edx, es:real_es
                              shl                           edx, 4
                              mov                           edi, es:real_edi
                              add                           edi, edx
                              mov                           al, byte ptr es:real_eax
                              mov                           cx, word ptr es:real_ecx
                              mov                           es, es:big_selector
                          rep stos                     byte ptr es:[edi]
                              pop                           es
                              sub                           edi, edx
                              mov                           es:real_edi, edi
                              mov                      word ptr es:real_ecx, cx
                              inc                           es:real_ip
                              inc                           es:real_ip
                              pop                           di
                              iret
callback_fast_0054:
                              push                          es
                              movzx                         edx, es:real_es
                              shl                           edx, 4
                              mov                           edi, es:real_edi
                              add                           edi, edx
                              mov                           ax, word ptr es:real_eax
                              mov                           es, es:big_selector
                              stos                     word ptr es:[edi]
                              pop                           es
                              sub                           edi, edx
                              mov                           es:real_edi, edi
                              inc                           es:real_ip
                              pop                           di
                              iret
callback_fast_0055:
                              push                          es
                              movzx                         edx, es:real_es
                              shl                           edx, 4
                              mov                           edi, es:real_edi
                              add                           edi, edx
                              mov                           eax, dword ptr es:real_eax
                              mov                           es, es:big_selector
                              stos                    dword ptr es:[edi]
                              pop                           es
                              sub                           edi, edx
                              mov                           es:real_edi, edi
                              inc                           es:real_ip
                              inc                           es:real_ip
                              pop                           di
                              iret
callback_fast_0056:
                              push                          es
                              movzx                         edx, es:real_es
                              shl                           edx, 4
                              mov                           edi, es:real_edi
                              add                           edi, edx
                              mov                           ax, word ptr es:real_eax
                              mov                           cx, word ptr es:real_ecx
                              mov                           es, es:big_selector
                          rep stos                     word ptr es:[edi]
                              pop                           es
                              sub                           edi, edx
                              mov                           es:real_edi, edi
                              mov                      word ptr es:real_ecx, cx
                              inc                           es:real_ip
                              inc                           es:real_ip
                              pop                           di
                              iret
callback_fast_0057:
                              push                          es
                              movzx                         edx, es:real_es
                              shl                           edx, 4
                              mov                           edi, es:real_edi
                              add                           edi, edx
                              mov                           eax, dword ptr es:real_eax
                              mov                           cx, word ptr es:real_ecx
                              mov                           es, es:big_selector
                          rep stos                    dword ptr es:[edi]
                              pop                           es
                              sub                           edi, edx
                              mov                           es:real_edi, edi
                              mov                      word ptr es:real_ecx, cx
                              inc                           es:real_ip
                              inc                           es:real_ip
                              inc                           es:real_ip
                              pop                           di
                              iret
callback_fast_0058:
                              movzx                         edx, es:real_ds
                              shl                           edx, 4
                              mov                           esi, es:real_esi
                              add                           esi, edx
                              mov                           ds, es:big_selector
                              lods                     byte ptr ds:[esi]
                              mov                      byte ptr es:real_eax, al
                              sub                           esi, edx
                              mov                           es:real_esi, esi
                              inc                           es:real_ip
                              pop                           di
                              iret
callback_fast_005C:
                              movzx                         edx, es:real_ds
                              shl                           edx, 4
                              mov                           esi, es:real_esi
                              add                           esi, edx
                              mov                           ds, es:big_selector
                              lods                     word ptr ds:[esi]
                              mov                      word ptr es:real_eax, ax
                              sub                           esi, edx
                              mov                           es:real_esi, esi
                              inc                           es:real_ip
                              pop                           di
                              iret
callback_fast_005D:
                              movzx                         edx, es:real_ds
                              shl                           edx, 4
                              mov                           esi, es:real_esi
                              add                           esi, edx
                              mov                           ds, es:big_selector
                              lods                    dword ptr ds:[esi]
                              mov                     dword ptr es:real_eax, eax
                              sub                           esi, edx
                              mov                           es:real_esi, esi
                              inc                           es:real_ip
                              inc                           es:real_ip
                              pop                           di
                              iret
callback_fast_0068:
                              movzx                         ebx, es:real_ds
                              shl                           ebx, 4
                              add                           ebx, es:real_ebx
                              mov                           al, byte ptr es:real_eax
                              mov                           ds, es:big_selector
                              xlat                     byte ptr ds:[ebx]
                              mov                      byte ptr es:real_eax, al
                              inc                           es:real_ip
                              pop                           di
                              iret

callback_build_format_1_0:
                              test                          ah, 02h
                              jz                            callback_build_format_1_1
                              mov                           al, 0f3h
                              stos                     byte ptr es:[di]
                              inc                           es:real_ip
callback_build_format_1_1:
                              test                          ah, 01h
                              jz                            callback_build_format_1_2
                              mov                           al, 066h
                              stos                     byte ptr es:[di]
                              inc                           es:real_ip
callback_build_format_1_2:
                              mov                           al, 067h
                              stos                     byte ptr es:[di]
                              shr                           ax, 0ah
                              add                           al, 094h
                              cmp                           al, 0a7h
                              jbe                           callback_build_format_1_end   
                              add                           al, 002h
                              cmp                           al, 0afh
                              jbe                           callback_build_format_1_end   
                              mov                           al, 0d7h
callback_build_format_1_end:
                              stos                     byte ptr es:[di]
                              inc                           es:real_ip
                              jmp                           callback_build_format_end   

callback_build_format_2:
                              mov                           al, 067h
                              stos                     byte ptr es:[di]
                              mov                           ch, ah
                              and                           ah, 0e3h
                              mov                           al, 088h
                              cmp                           ah, 080h
                              je                            callback_build_format_2_end   
                              mov                           al, 089h
                              cmp                           ah, 081h
                              je                            callback_build_format_2_end   
                              mov                           al, 08ah
                              cmp                           ah, 082h
                              je                            callback_build_format_2_end   
                              mov                           al, 08bh
                              cmp                           ah, 083h
                              je                            callback_build_format_2_end   
                              mov                           al, 003h
                              cmp                           ah, 0a0h
                              je                            callback_build_format_2_end   
                              mov                           al, 013h
                              cmp                           ah, 0a1h
                              je                            callback_build_format_2_end   
                              mov                           al, 02bh
                              cmp                           ah, 0a2h
                              je                            callback_build_format_2_end   
                              mov                           al, 00bh
                              cmp                           ah, 0a3h
                              je                            callback_build_format_2_end   
                              mov                           al, 0c7h
                              cmp                           ah, 0c0h
                              je                            callback_build_format_2_end   
                              mov                           al, 0f7h
                              cmp                           ah, 0c1h
                              je                            callback_build_format_2_end   
                              mov                           al, 038h
                              cmp                           ah, 0e0h
                              je                            callback_build_format_2_end   
                              mov                           al, 039h
                              cmp                           ah, 0e1h
                              je                            callback_build_format_2_end   
                              mov                           al, 03ah
                              cmp                           ah, 0e2h
                              je                            callback_build_format_2_end   
                              mov                           al, 03bh
                              cmp                           ah, 0e3h
                              je                            callback_build_format_2_end   
callback_build_format_2_end:
                              stos                     byte ptr es:[di]
                              inc                           ebx
                              inc                           es:real_ip
                              and                           ch, 01ch
                              shr                           cx, 00ah
                              jmp                           callback_build_format_bytes

callback_load_machine:
                              mov                           eax, es:real_eax
                              mov                           ebx, es:real_ebx
                              mov                           ecx, es:real_ecx
                              mov                           edx, es:real_edx
                              mov                           esi, es:real_esi
                              mov                           edi, es:real_edi

callback_type_dpmi:
                              cmp                           es:type_call, 00h
                              jne                           callback_type_other
                              mov                           es:[00h+seg_ds_client], ds
                              push                          ax
                              mov                           ax, es:real_ds
                              mov                           es:[02h+seg_ds_client], ax
                              pop                           ax
IFDEF TRACE
                              push                          ax
                              mov                           ax, es:real_ip
                              mov                      word ptr es:[00h+extra_data], ax
                              mov                           ax, es:real_cs
                              mov                      word ptr es:[02h+extra_data], ax
                              pop                           ax
                              mov                           es:interrupt_state, 00h
                              call                          machine_dump_prot
                              mov                           es:interrupt_state, 01h
ENDIF
                              int                           31h
                              jmp                           callback_return

callback_type_other:
                              push                          es
                              push                          ds
                              push                          ds
                              cmp                           es:real_ds, 0000h
                              jne                           callback_type_other_es
                              mov                           ds, cs:big_selector
callback_type_other_es:
                              cmp                           es:real_es, 0000h
                              pop                           es
                              jne                           callback_type_flags
                              mov                           es, cs:big_selector
callback_type_flags:
                              push                          ax
                              push                          bx
                              pushf
                              pop                           ax
                              and                           ax, 0300h
                              mov                           bx, cs:real_flags
                              and                           bx, 0cffh
                              or                            ax, bx
                              push                          ax
                              popf
                              pop                           bx
                              pop                           ax
callback_type_run:
                              db                            10h dup(90h)
callback_type_segregs:
                              pop                           ds
                              pop                           es

callback_return:
                              push                          ax
                              push                          bx
                              pushf
                              pop                           ax
                              and                           ax, 0cffh
                              mov                           bx, es:real_flags
                              and                           bx, 0300h
                              or                            ax, bx
                              mov                           es:real_flags, ax
                              pop                           bx
                              pop                           ax
                              mov                           es:real_eax, eax
                              mov                           es:real_ebx, ebx
                              mov                           es:real_ecx, ecx
                              mov                           es:real_edx, edx
                              mov                           es:real_esi, esi
                              mov                           es:real_edi, edi
                              pop                           di
                              iret
callback_proc                 endp

IFDEF EXCP
exception_proc                proc                          near
                              push                          es
                              mov                           es, cs:seg_ds
IFDEF TRACE
                              push                          eax
                              mov                           eax, es:callback_global_occurrence
                              mov                           es:extra_data, eax
                              pop                           eax
                              mov                           es:interrupt_state, 00h
                              call                          machine_dump_prot
                              mov                           es:interrupt_state, 01h
                              push                          ax
                              mov                           ax, es:real_flags
                              mov                      word ptr es:[00h+extra_data], ax
                              movzx                         ax, es:type_call
                              mov                      word ptr es:[02h+extra_data], ax
                              pop                           ax
                              mov                           es:interrupt_state, 00h
                              call                          machine_dump_prot
                              mov                           es:interrupt_state, 01h
                              push                          ax
                              mov                           ax, es:real_ip
                              mov                      word ptr es:[00h+extra_data], ax
                              mov                           ax, es:real_cs
                              mov                      word ptr es:[02h+extra_data], ax
                              pop                           ax
                              mov                           es:interrupt_state, 00h
                              call                          machine_dump_prot
                              mov                           es:interrupt_state, 01h
                              push                          ax
                              mov                           ax, es:real_ds
                              mov                      word ptr es:[00h+extra_data], ax
                              mov                           ax, es:real_es
                              mov                      word ptr es:[02h+extra_data], ax
                              pop                           ax
                              mov                           es:interrupt_state, 00h
                              call                          machine_dump_prot
                              mov                           es:interrupt_state, 01h
                              push                          eax
                              mov                           eax, dword ptr [00h+callback_type_run]
                              mov                           es:extra_data, eax
                              pop                           eax
                              mov                           es:interrupt_state, 00h
                              call                          machine_dump_prot
                              mov                           es:interrupt_state, 01h
                              push                          eax
                              mov                           eax, dword ptr [04h+callback_type_run]
                              mov                           es:extra_data, eax
                              pop                           eax
                              mov                           es:interrupt_state, 00h
                              call                          machine_dump_prot
                              mov                           es:interrupt_state, 01h
ENDIF
                              pop                           es
                              jmp                     dword ptr cs:[prot_exception]
                              retf
exception_proc                endp
ENDIF

;====================================================================================================================================================;
;                             M A I N                       D A T A
;====================================================================================================================================================;

IFDEF TRACE

;====================================================================================================================================================;
;
; Tracing fields for use by machine_dump
;
;====================================================================================================================================================;
                              align                         4
extra_data                    dd                            0
trace_file                    db                            "test.log", 0
trace_buffer                  db                            " = 00000000"
trace_descr                   db                            "00000000"
trace_separ                   db                            ", "
trace_line                    db                            0dh, 0ah
trace_eax                     db                            "eax"
trace_ebx                     db                            "ebx"
trace_ecx                     db                            "ecx"
trace_edx                     db                            "edx"
trace_esp                     db                            "esp"
trace_ebp                     db                            "ebp"
trace_esi                     db                            "esi"
trace_edi                     db                            "edi"
trace_ip                      db                            "ip"
trace_eflags                  db                            "flg"
trace_extra                   db                            "ext"
trace_idt                     db                            "idt"
trace_gdt                     db                            "gdt"
trace_sw                      db                            "sw"
trace_lt                      db                            "lt"
trace_tr                      db                            "tr"
trace_ds                      db                            "ds"
trace_es                      db                            "es"
trace_ss                      db                            "ss"
trace_cs                      db                            "cs"
trace_fs                      db                            "fs"
trace_gs                      db                            "gs"
trace_rs                      db                            "rs"
trace_stack_1                 db                            "s1"
trace_stack_2                 db                            "s2"
trace_interrupt_code          db                            "ic"
trace_interrupt_occurs        db                            "occ"
trace_interrupt_location      db                            "loc"
ENDIF

;====================================================================================================================================================;
;
; Dispatcher Data proper
;
;====================================================================================================================================================;

msg_banner                    db                            "Ultima 7 Helper for Windows 9x, Version 0.5", 0dh, 0dh, 24h
pgm_intro                     db                            "intro.exe", 0
pgm_menu                      db                            "mainmenu.exe", 0
pgm_u71                       db                            "u7.exe", 0
msg_exit_u71                  db                            "Thank you for playing Ultima VII, The Black Gate!", 0dh, 0dh, 24h
arg_psw_u71                   db                            "ereiamjh", 0
pgm_u72                       db                            "si.exe", 0
msg_exit_u72                  db                            "Thank you for playing Ultima VII Part II : Serpent Isle!", 0dh, 0dh, 24h
arg_psw_u72                   db                            "hisss", 0
pgm_end                       db                            "endgame.exe", 0
pgm_extra                     db                            "surprise.exe", 0
arg_v                         db                            "v", 0
arg_n                         db                            "n", 0
arg_c                         db                            "c", 0
arg_l                         db                            "l", 0
arg_u1                        db                            "u1", 0
arg_m                         db                            "m", 0
arg_blank                     db                            " ", 0
arg_vr                        db                            "v r", 0
msg_error                     db                            "An error had occurred loading a program.", 0dh, 0dh, 24h

machine_state                 db                            0
interrupt_state               db                            0
video_state                   db                            0
is_u72                        db                            0
program_state                 db                            0
executable_state              db                            0

;====================================================================================================================================================;
;
; Hooks and DPMI Interface Data
;
;====================================================================================================================================================;

                              even

int_21                        dd                            0
int_2f                        dd                            0
int_03                        dd                            0
xms_hd                        dd                            0
code_word                     dw                            0ffffh
old_sp                        dw                            0
old_ss                        dw                            0

ini_modesw                    dd                            0
raw_real_save_restore         dd                            0
raw_prot_save_restore         dd                            0
raw_real_switch               dd                            0
raw_prot_switch               dd                            0
raw_modees                    dw                            0
seg_real_ds                   dw                            0
seg_real_cs                   dw                            0
seg_real_es                   dw                            0
seg_real_ss                   dw                            0
seg_prot_ds                   dw                            0
seg_prot_cs                   dw                            0
seg_prot_es                   dw                            0
seg_prot_ss                   dw                            0
seg_prot_0000                 dw                            0
seg_prot_a000                 dw                            0
big_selector                  dw                            0
big_descriptor                db                            0ffh, 0ffh, 000h, 000h, 000h, 0f3h, 0cfh, 000h
seg_ds_client                 dw                            0, 0
type_call                     db                            0
pgm_base                      dw                            0
                              even
IFDEF EXCP
prot_exception                dd                            0
ENDIF
real_callback                 dd                            0
real_edi                      dd                            0
real_esi                      dd                            0
real_ebp                      dd                            0
real_esp                      dd                            0
real_ebx                      dd                            0
real_edx                      dd                            0
real_ecx                      dd                            0
real_eax                      dd                            0
real_flags                    dw                            0
real_es                       dw                            0
real_ds                       dw                            0
real_fs                       dw                            0
real_gs                       dw                            0
real_ip                       dw                            0
real_cs                       dw                            0
real_sp                       dw                            0
real_ss                       dw                            0
dpmi_block_00                 db                            9 dup(0)
dpmi_block_01                 db                            9 dup(0)
dpmi_block_02                 db                            9 dup(0)
dpmi_block_03                 db                            9 dup(0)

IFDEF TRACE
callback_global_occurrence    dd                            0
callback_occurrence           dd                            100h dup(0)
callback_patchloc             dd                            300h dup(0, 0)
ENDIF

;====================================================================================================================================================;
;
; The Patch Table
;
;====================================================================================================================================================;

u71_main_patch                dw                            17D9h
                              dw                            14D7h-17D9h
                              dw                            0071h, 0080h, 008Bh, 00D9h, 0112h, 0152h, 01D7h, 01D9h
                              dw                            0252h, 0254h, 0288h, 02B8h, 02E3h, 030Dh, 0337h, 0361h
                              dw                            03A2h, 03EEh, 03F6h, 0433h, 043Bh, 0498h, 04A2h, 04F6h
                              dw                            0500h, 05BFh, 05D1h, 05E6h, 05F0h, 05FBh, 0650h, 065Ah
                              dw                            06B0h, 06BAh, 0704h, 0748h, 078Eh, 07CCh, 07CFh, 07D2h
                              dw                            07D5h, 07D8h, 07DBh, 07DEh, 07E1h, 07E4h, 07E7h, 07EAh
                              dw                            07EDh, 07F0h, 07F3h, 07F6h, 07F9h, 07FCh, 07FFh, 0802h
                              dw                            0805h, 0808h, 080Bh, 080Eh, 0811h, 0814h, 0817h, 081Ah
                              dw                            081Dh, 0820h, 0823h, 0826h, 0829h, 082Ch, 082Fh, 0832h
                              dw                            0835h, 0838h, 083Bh, 083Eh, 0841h, 0844h, 0847h, 084Ah
                              dw                            084Dh, 0850h, 0853h, 0856h, 0859h, 085Ch, 085Fh, 0862h
                              dw                            0865h, 0868h, 086Bh, 086Eh, 0871h, 0874h, 0877h, 087Ah
                              dw                            087Dh, 0880h, 0883h, 0886h, 0889h, 088Ch, 088Fh, 0892h
                              dw                            0895h, 0898h, 089Bh, 089Eh, 08A1h, 08A4h, 08A7h, 08AAh
                              dw                            08ADh, 08B0h, 08B3h, 08B6h, 08B9h, 0922h, 0924h, 0926h
                              dw                            0967h, 0A2Eh, 0A36h, 0A46h, 0A52h, 0ABCh, 0ACFh, 0AEEh
                              dw                            0AF9h, 0B02h, 0B0Ah, 0B65h, 0BE5h, 0BF6h, 0C0Fh, 0C14h
                              dw                            0C1Fh, 0C25h, 0C33h, 0C5Bh, 0C86h, 0C9Eh, 0CE9h, 0D00h
                              dw                            0D09h, 0E4Eh, 0E65h, 0E6Eh, 0F08h, 0F18h, 0F37h, 0F3Ch
                              dw                            0F4Ah, 0F50h, 0F61h, 0F8Ch, 0FBDh, 0FD8h, 1026h, 103Dh
                              dw                            1046h, 1189h, 11A0h, 11A9h, 1258h, 1269h, 1273h, 1283h
                              dw                            1291h, 129Ch, 12B4h, 12C6h, 12D1h, 12E4h, 12FFh, 1309h
                              dw                            1314h, 1325h, 132Eh, 133Bh, 1349h, 1352h, 1364h, 1380h
                              dw                            1389h, 13C7h, 1403h, 140Ch, 141Ch, 1425h, 1432h, 143Bh
                              dw                            147Dh, 14B5h, 14C8h, 14D1h, 14DFh, 14EDh, 14F6h, 1505h
                              dw                            1544h, 1557h, 1560h, 156Eh, 157Ch, 1585h, 15DBh, 15E4h
                              dw                            16AFh, 16C0h, 16CAh, 16DAh, 16E8h, 16F3h, 170Bh, 171Dh
                              dw                            1728h, 173Bh, 175Ch, 1760h, 1779h, 177Ch, 1782h, 1797h
                              dw                            17AFh, 17B3h, 17CCh, 17CFh, 17D5h, 17F8h, 17FCh, 1806h
                              dw                            1818h, 181Bh, 181Dh, 183Eh, 185Ah, 1863h, 18A0h, 18E3h
                              dw                            18E7h, 1900h, 1903h, 1909h, 1929h, 192Dh, 1946h, 1949h
                              dw                            194Fh, 1965h, 196Eh, 19B0h, 19E8h, 1A02h, 1A06h, 1A1Fh
                              dw                            1A22h, 1A28h, 1A4Ch, 1A50h, 1A5Ah, 1A6Ch, 1A6Fh, 1A71h
                              dw                            1A8Fh, 1ACCh, 1ADFh, 1AE8h, 1AF6h, 1B04h, 1B0Dh, 1B68h
                              dw                            1B6Ch, 1B85h, 1B88h, 1B8Eh
                              dw                            0

u71_game_patch                dw                            3FC8h
                              dw                            0B49h-3FC8h
                              dw                            0027h, 0033h, 0066h, 0072h, 00A5h, 00A9h, 00DCh, 0114h
                              dw                            0117h, 0163h, 0166h
                              dw                            0FD5h-3FC8h
                              dw                            0043h, 004Dh, 0057h, 00EBh, 00F0h, 011Ah, 011Fh, 0161h
                              dw                            0166h, 0196h, 01CAh, 01CFh, 01E1h, 01E6h, 022Ah, 0244h
                              dw                            024Fh, 0266h, 027Ah, 028Ah, 029Bh, 02A6h, 02D5h, 02E7h
                              dw                            0338h, 0342h, 034Ch, 03DFh, 03E7h, 03EFh, 0472h, 047Eh
                              dw                            048Ah, 04C1h, 04C8h, 04FDh, 0504h, 0538h, 053Fh, 0550h
                              dw                            059Eh, 05DFh, 05E7h, 05EAh, 060Bh, 0624h, 0629h, 0634h
                              dw                            06A6h, 06A9h, 06AFh, 06B2h, 06B8h, 06BBh, 06C1h, 06C4h
                              dw                            06CAh, 06CDh, 06D3h, 06D6h, 06DCh, 06DFh, 06E5h, 06E8h
                              dw                            0761h, 0770h, 077Bh, 07C9h, 0802h, 087Ch, 0882h, 0886h
                              dw                            0890h, 0894h, 08A1h, 08A7h, 08AAh, 08B3h, 08B6h, 08C3h
                              dw                            08C6h, 08CAh, 08CEh, 08D1h, 08D7h, 08DFh, 08F4h, 0911h
                              dw                            0982h, 0A07h, 0A09h, 0A82h, 0A84h, 0AB8h, 0AE8h, 0B13h
                              dw                            0B3Dh, 0B67h, 0B91h, 0BD2h, 0C1Eh, 0C26h, 0C63h, 0C6Bh
                              dw                            0CC8h, 0CD2h, 0D26h, 0D30h, 0DEFh, 0E01h, 0E16h, 0E20h
                              dw                            0E2Bh, 0E80h, 0E8Ah, 0EE0h, 0EEAh, 0F34h, 0F78h, 0FBEh
                              dw                            0FFCh, 0FFFh, 1002h, 1005h, 1008h, 100Bh, 100Eh, 1011h
                              dw                            1014h, 1017h, 101Ah, 101Dh, 1020h, 1023h, 1026h, 1029h
                              dw                            102Ch, 102Fh, 1032h, 1035h, 1038h, 103Bh, 103Eh, 1041h
                              dw                            1044h, 1047h, 104Ah, 104Dh, 1050h, 1053h, 1056h, 1059h
                              dw                            105Ch, 105Fh, 1062h, 1065h, 1068h, 106Bh, 106Eh, 1071h
                              dw                            1074h, 1077h, 107Ah, 107Dh, 1080h, 1083h, 1086h, 1089h
                              dw                            108Ch, 108Fh, 1092h, 1095h, 1098h, 109Bh, 109Eh, 10A1h
                              dw                            10A4h, 10A7h, 10AAh, 10ADh, 10B0h, 10B3h, 10B6h, 10B9h
                              dw                            10BCh, 10BFh, 10C2h, 10C5h, 10C8h, 10CBh, 10CEh, 10D1h
                              dw                            10D4h, 10D7h, 10DAh, 10DDh, 10E0h, 10E3h, 10E6h, 10E9h
                              dw                            1152h, 1154h, 1156h, 1197h, 125Eh, 1266h, 1276h, 1282h
                              dw                            12EBh, 12F8h, 1380h, 1393h, 13B2h, 13BDh, 13C6h, 13CEh
                              dw                            1429h, 14A9h, 14BAh, 14D3h, 14D8h, 14E3h, 14E9h, 14F7h
                              dw                            151Fh, 154Ah, 1562h, 15ADh, 15C4h, 15CDh, 1712h, 1729h
                              dw                            1732h, 17CCh, 17DCh, 17FBh, 1800h, 180Eh, 1814h, 1825h
                              dw                            1850h, 1881h, 189Ch, 18EAh, 1901h, 190Ah, 1A4Dh, 1A64h
                              dw                            1A6Dh, 1B02h, 1B14h, 1B29h, 1B33h, 1B3Eh, 1BD4h, 1BE5h
                              dw                            1BEFh, 1BFFh, 1C0Dh, 1C18h, 1C30h, 1C42h, 1C4Dh, 1C60h
                              dw                            1C7Bh, 1C85h, 1C90h, 1CA1h, 1CAAh, 1CB7h, 1CC5h, 1CCEh
                              dw                            1CE0h, 1CFCh, 1D05h, 1D43h, 1D7Fh, 1D88h, 1D98h, 1DA1h
                              dw                            1DAEh, 1DB7h, 1DF9h, 1E31h, 1E44h, 1E4Dh, 1E5Bh, 1E69h
                              dw                            1E72h, 1E81h, 1EC0h, 1ED3h, 1EDCh, 1EEAh, 1EF8h, 1F01h
                              dw                            1F57h, 1F60h, 2004h, 2015h, 201Fh, 2030h, 203Eh, 2049h
                              dw                            2063h, 2074h, 2087h, 2091h, 20A7h, 20BAh, 20C7h, 20DFh
                              dw                            20E1h, 20FBh, 2117h, 2120h, 2172h, 21B9h, 21D2h, 21E7h
                              dw                            21F0h, 2246h, 2295h, 22A2h, 22B8h, 22BAh, 22D0h, 230Eh
                              dw                            2321h, 232Ah, 2338h, 2346h, 234Fh, 23AAh, 245Fh, 2470h
                              dw                            247Ah, 248Bh, 2499h, 24A4h, 24BEh, 24CFh, 24E5h, 24EFh
                              dw                            2512h, 2515h, 2517h, 252Eh, 2548h, 254Bh, 254Dh, 2576h
                              dw                            2579h, 257Bh, 2599h, 25B5h, 25BEh, 2612h, 2699h, 269Ch
                              dw                            269Eh, 26C7h, 26CAh, 26CCh, 26E4h, 26EDh, 2744h, 278Fh
                              dw                            27A9h, 27ACh, 27AEh, 27D5h, 27D8h, 27DAh, 27F4h, 2834h
                              dw                            2847h, 2850h, 285Eh, 286Ch, 2875h, 28FDh, 2900h, 2902h
                              dw                            29D4h, 29E5h, 29EFh, 2A00h, 2A0Eh, 2A19h, 2A33h, 2A44h
                              dw                            2A5Ah, 2A64h, 2A87h, 2A8Bh, 2AA4h, 2AA7h, 2AADh, 2ACAh
                              dw                            2AE4h, 2AE8h, 2B01h, 2B04h, 2B0Ah, 2B36h, 2B3Ah, 2B44h
                              dw                            2B5Eh, 2B61h, 2B63h, 2B8Ch, 2BA8h, 2BB1h, 2C05h, 2C8Ch
                              dw                            2C90h, 2CA9h, 2CACh, 2CB2h, 2CE0h, 2CE4h, 2CFDh, 2D00h
                              dw                            2D06h, 2D23h, 2D2Ch, 2D84h, 2DCFh, 2DE9h, 2DEDh, 2E06h
                              dw                            2E09h, 2E0Fh, 2E3Bh, 2E3Fh, 2E49h, 2E63h, 2E66h, 2E68h
                              dw                            2E8Dh, 2ECDh, 2EE0h, 2EE9h, 2EF7h, 2F05h, 2F0Eh, 2F96h
                              dw                            2F9Ah, 2FB3h, 2FB6h, 2FBCh, 3097h, 30A8h, 30B2h, 30C2h
                              dw                            30D0h, 30DBh, 30F3h, 3105h, 3110h, 3123h, 3144h, 3148h
                              dw                            3161h, 3164h, 316Ah, 317Fh, 3197h, 319Bh, 31B4h, 31B7h
                              dw                            31BDh, 31E0h, 31E4h, 31EEh, 3200h, 3203h, 3205h, 3226h
                              dw                            3242h, 324Bh, 3288h, 32CBh, 32CFh, 32E8h, 32EBh, 32F1h
                              dw                            3311h, 3315h, 332Eh, 3331h, 3337h, 334Dh, 3356h, 3398h
                              dw                            33D0h, 33EAh, 33EEh, 3407h, 340Ah, 3410h, 3434h, 3438h
                              dw                            3442h, 3454h, 3457h, 3459h, 3477h, 34B4h, 34C7h, 34D0h
                              dw                            34DEh, 34ECh, 34F5h, 3550h, 3554h, 356Dh, 3570h, 3576h
                              dw                            364Bh, 365Ch, 3666h, 3676h, 3684h, 368Fh, 36A7h, 36B9h
                              dw                            36C4h, 36D6h, 36F7h, 36FAh, 36FCh, 370Bh, 3723h, 3726h
                              dw                            3728h, 3739h, 3746h, 3749h, 374Bh, 3761h, 377Dh, 3786h
                              dw                            37C4h, 3807h, 380Ah, 380Ch, 3827h, 382Ah, 382Ch, 383Dh
                              dw                            3846h, 3888h, 38C0h, 38DAh, 38DDh, 38DFh, 38F1h, 38FEh
                              dw                            3901h, 3903h, 3916h, 3953h, 3966h, 396Fh, 397Dh, 398Bh
                              dw                            3994h, 39EFh, 39F2h, 39F4h, 3A61h, 3A7Ah, 3A93h, 3AACh
                              dw                            3AD4h, 3ADEh, 3B18h, 3B31h, 3B4Ah, 3B63h, 3CC7h, 3CE0h
                              dw                            3CFDh, 3D07h, 3D4Fh, 3DD6h, 3DE0h, 3DE3h, 3DE5h
                              dw                            3A02h-3FC8h
                              dw                            0016h, 0023h, 003Ch, 0049h, 0062h
                              dw                            3A09h-3FC8h
                              dw                            0029h, 002Eh, 0033h, 0038h, 003Dh, 0045h, 0049h, 0051h
                              dw                            005Fh, 007Dh, 0082h, 00ABh, 00B5h, 00C6h, 00D2h, 00D9h
                              dw                            00E9h, 0108h, 010Ch, 0126h, 0130h
                              dw                            3A88h-3FC8h
                              dw                            0083h, 0089h, 00A4h, 00C5h, 00CBh
                              dw                            3A95h-3FC8h
                              dw                            0024h, 002Ah, 01A6h, 01D1h, 01EBh, 0209h, 0224h, 022Ah
                              dw                            3ADAh-3FC8h
                              dw                            00FAh, 0141h, 014Ch, 016Ah
                              dw                            0

u71_end_patch                 dw                            13BCh
                              dw                            1290h-13BCh
                              dw                            002Eh, 00B3h, 00B5h, 012Eh, 0130h, 0164h, 0194h, 01BFh
                              dw                            01E9h, 0213h, 023Dh, 027Eh, 02CAh, 02D2h, 030Fh, 0317h
                              dw                            0374h, 037Eh, 03D2h, 03DCh, 049Bh, 04ADh, 04C2h, 04CCh
                              dw                            04D7h, 052Ch, 0536h, 058Ch, 0596h, 05E0h, 0624h, 066Ah
                              dw                            06A8h, 06ABh, 06AEh, 06B1h, 06B4h, 06B7h, 06BAh, 06BDh
                              dw                            06C0h, 06C3h, 06C6h, 06C9h, 06CCh, 06CFh, 06D2h, 06D5h
                              dw                            06D8h, 06DBh, 06DEh, 06E1h, 06E4h, 06E7h, 06EAh, 06EDh
                              dw                            06F0h, 06F3h, 06F6h, 06F9h, 06FCh, 06FFh, 0702h, 0705h
                              dw                            0708h, 070Bh, 070Eh, 0711h, 0714h, 0717h, 071Ah, 071Dh
                              dw                            0720h, 0723h, 0726h, 0729h, 072Ch, 072Fh, 0732h, 0735h
                              dw                            0738h, 073Bh, 073Eh, 0741h, 0744h, 0747h, 074Ah, 074Dh
                              dw                            0750h, 0753h, 0756h, 0759h, 075Ch, 075Fh, 0762h, 0765h
                              dw                            0768h, 076Bh, 076Eh, 0771h, 0774h, 0777h, 077Ah, 077Dh
                              dw                            0780h, 0783h, 0786h, 0789h, 078Ch, 078Fh, 0792h, 0795h
                              dw                            07FEh, 0800h, 0802h, 0843h
                              dw                            1356h-13BCh
                              dw                            00FEh, 0145h, 0150h, 016Eh
                              dw                            0

u72_int_patch                 dw                            13F1h
                              dw                            12C8h-13F1h
                              dw                            003Ah, 00BFh, 00C1h, 013Ah, 013Ch, 0170h, 01A0h, 01CBh
                              dw                            01F5h, 021Fh, 0249h, 028Ah, 02D6h, 02DEh, 031Bh, 0323h
                              dw                            037Fh, 0389h, 03DBh, 03E5h, 04A7h, 04B2h, 0506h, 0510h
                              dw                            0564h, 056Eh, 05B6h, 05F8h, 063Ch, 0678h, 067Bh, 067Eh
                              dw                            0681h, 0684h, 0687h, 068Ah, 068Dh, 0690h, 0693h, 0696h
                              dw                            0699h, 069Ch, 069Fh, 06A2h, 06A5h, 06A8h, 06ABh, 06AEh
                              dw                            06B1h, 06B4h, 06B7h, 06BAh, 06BDh, 06C0h, 06C3h, 06C6h
                              dw                            06C9h, 06CCh, 06CFh, 06D2h, 06D5h, 06D8h, 06DBh, 06DEh
                              dw                            06E1h, 06E4h, 06E7h, 06EAh, 06EDh, 06F0h, 06F3h, 06F6h
                              dw                            06F9h, 06FCh, 06FFh, 0702h, 0705h, 0708h, 070Bh, 070Eh
                              dw                            0711h, 0714h, 0717h, 071Ah, 071Dh, 0720h, 0723h, 0726h
                              dw                            0729h, 072Ch, 072Fh, 0732h, 0735h, 0738h, 073Bh, 073Eh
                              dw                            0741h, 0744h, 0747h, 074Ah, 074Dh, 0750h, 0753h, 0756h
                              dw                            0759h, 075Ch, 075Fh, 0762h, 0765h, 07CCh, 07CEh, 07D0h
                              dw                            080Fh
                              dw                            138Bh-13F1h
                              dw                            00FAh, 013Eh, 0149h, 0167h
                              dw                            0

u72_main_patch                dw                            1821h
                              dw                            14BEh-1821h
                              dw                            006Dh, 007Ch, 0087h, 00D5h, 010Eh, 014Eh, 01D3h, 01D5h
                              dw                            024Eh, 0250h, 0284h, 02B4h, 02DFh, 0309h, 0333h, 035Dh
                              dw                            039Eh, 03EAh, 03F2h, 042Fh, 0437h, 0494h, 049Eh, 04F2h
                              dw                            04FCh, 05BBh, 05CDh, 05E2h, 05ECh, 05F7h, 064Ch, 0656h
                              dw                            06ACh, 06B6h, 0700h, 0744h, 078Ah, 07C8h, 07CBh, 07CEh
                              dw                            07D1h, 07D4h, 07D7h, 07DAh, 07DDh, 07E0h, 07E3h, 07E6h
                              dw                            07E9h, 07ECh, 07EFh, 07F2h, 07F5h, 07F8h, 07FBh, 07FEh
                              dw                            0801h, 0804h, 0807h, 080Ah, 080Dh, 0810h, 0813h, 0816h
                              dw                            0819h, 081Ch, 081Fh, 0822h, 0825h, 0828h, 082Bh, 082Eh
                              dw                            0831h, 0834h, 0837h, 083Ah, 083Dh, 0840h, 0843h, 0846h
                              dw                            0849h, 084Ch, 084Fh, 0852h, 0855h, 0858h, 085Bh, 085Eh
                              dw                            0861h, 0864h, 0867h, 086Ah, 086Dh, 0870h, 0873h, 0876h
                              dw                            0879h, 087Ch, 087Fh, 0882h, 0885h, 0888h, 088Bh, 088Eh
                              dw                            0891h, 0894h, 0897h, 089Ah, 089Dh, 08A0h, 08A3h, 08A6h
                              dw                            08A9h, 08ACh, 08AFh, 08B2h, 08B5h, 091Eh, 0920h, 0922h
                              dw                            0963h, 0A2Ah, 0A32h, 0A42h, 0A4Eh, 0AB8h, 0ACBh, 0AEAh
                              dw                            0AF5h, 0AFEh, 0B06h, 0B61h, 0BE1h, 0BF2h, 0C0Bh, 0C10h
                              dw                            0C1Bh, 0C21h, 0C2Fh, 0C57h, 0C82h, 0C9Ah, 0CE5h, 0CFCh
                              dw                            0D05h, 0E4Ah, 0E61h, 0E6Ah, 0F04h, 0F14h, 0F33h, 0F38h
                              dw                            0F46h, 0F4Ch, 0F5Dh, 0F88h, 0FB9h, 0FD4h, 1022h, 1039h
                              dw                            1042h, 1185h, 119Ch, 11A5h, 1254h, 1265h, 126Fh, 127Fh
                              dw                            128Dh, 1298h, 12B0h, 12C2h, 12CDh, 12E0h, 12FBh, 1305h
                              dw                            1310h, 1321h, 132Ah, 1337h, 1345h, 134Eh, 1360h, 137Ch
                              dw                            1385h, 13C3h, 13FFh, 1408h, 1418h, 1421h, 142Eh, 1437h
                              dw                            1479h, 14B1h, 14C4h, 14CDh, 14DBh, 14E9h, 14F2h, 1501h
                              dw                            1540h, 1553h, 155Ch, 156Ah, 1578h, 1581h, 15D7h, 15E0h
                              dw                            16ABh, 16BCh, 16C6h, 16D6h, 16E4h, 16EFh, 1707h, 1719h
                              dw                            1724h, 1737h, 1758h, 175Ch, 1775h, 1778h, 177Eh, 1793h
                              dw                            17ABh, 17AFh, 17C8h, 17CBh, 17D1h, 17F4h, 17F8h, 1802h
                              dw                            1814h, 1817h, 1819h, 183Ah, 1856h, 185Fh, 189Ch, 18DFh
                              dw                            18E3h, 18FCh, 18FFh, 1905h, 1925h, 1929h, 1942h, 1945h
                              dw                            194Bh, 1961h, 196Ah, 19ACh, 19E4h, 19FEh, 1A02h, 1A1Bh
                              dw                            1A1Eh, 1A24h, 1A48h, 1A4Ch, 1A56h, 1A68h, 1A6Bh, 1A6Dh
                              dw                            1A8Bh, 1AC8h, 1ADBh, 1AE4h, 1AF2h, 1B00h, 1B09h, 1B64h
                              dw                            1B68h, 1B81h, 1B84h, 1B8Ah
                              dw                            16D2h-1821h
                              dw                            00F6h, 013Dh, 0148h, 0166h
                              dw                            0

u72_game_patch                dw                            403Ah
                              dw                            09C5h-403Ah
                              dw                            0033h, 003Fh, 0072h, 007Eh, 00B1h, 00B5h, 00E8h, 0120h
                              dw                            0123h, 016Fh, 0172h
                              dw                            1D63h-403Ah
                              dw                            0023h, 0028h, 0052h, 0057h, 0099h, 009Eh, 00CEh, 0102h
                              dw                            0107h, 0119h, 011Eh, 0162h, 017Ch, 0187h, 019Eh, 01B2h
                              dw                            01C2h, 01D3h, 01DEh, 020Dh, 021Fh, 0270h, 027Ah, 0284h
                              dw                            0317h, 031Fh, 0327h, 03AAh, 03B6h, 03C2h, 03F9h, 0400h
                              dw                            0435h, 043Ch, 0470h, 0477h, 0488h, 04D6h, 0517h, 051Fh
                              dw                            0522h, 0543h, 055Ch, 0561h, 056Ch, 05DEh, 05E1h, 05E7h
                              dw                            05EAh, 05F0h, 05F3h, 05F9h, 05FCh, 0602h, 0605h, 060Bh
                              dw                            060Eh, 0614h, 0617h, 061Dh, 0620h, 0699h, 06A8h, 06B3h
                              dw                            0701h, 073Ah, 07B4h, 07BAh, 07BEh, 07C8h, 07CCh, 07D9h
                              dw                            07DFh, 07E2h, 07EBh, 07EEh, 07FBh, 07FEh, 0802h, 0806h
                              dw                            0809h, 080Fh, 0817h, 082Ch, 0849h, 08BAh, 093Fh, 0941h
                              dw                            09BAh, 09BCh, 09F0h, 0A20h, 0A4Bh, 0A75h, 0A9Fh, 0AC9h
                              dw                            0B0Ah, 0B56h, 0B5Eh, 0B9Bh, 0BA3h, 0C00h, 0C0Ah, 0C5Eh
                              dw                            0C68h, 0D27h, 0D39h, 0D4Eh, 0D58h, 0D63h, 0DB8h, 0DC2h
                              dw                            0E18h, 0E22h, 0E6Ch, 0EB0h, 0EF6h, 0F34h, 0F37h, 0F3Ah
                              dw                            0F3Dh, 0F40h, 0F43h, 0F46h, 0F49h, 0F4Ch, 0F4Fh, 0F52h
                              dw                            0F55h, 0F58h, 0F5Bh, 0F5Eh, 0F61h, 0F64h, 0F67h, 0F6Ah
                              dw                            0F6Dh, 0F70h, 0F73h, 0F76h, 0F79h, 0F7Ch, 0F7Fh, 0F82h
                              dw                            0F85h, 0F88h, 0F8Bh, 0F8Eh, 0F91h, 0F94h, 0F97h, 0F9Ah
                              dw                            0F9Dh, 0FA0h, 0FA3h, 0FA6h, 0FA9h, 0FACh, 0FAFh, 0FB2h
                              dw                            0FB5h, 0FB8h, 0FBBh, 0FBEh, 0FC1h, 0FC4h, 0FC7h, 0FCAh
                              dw                            0FCDh, 0FD0h, 0FD3h, 0FD6h, 0FD9h, 0FDCh, 0FDFh, 0FE2h
                              dw                            0FE5h, 0FE8h, 0FEBh, 0FEEh, 0FF1h, 0FF4h, 0FF7h, 0FFAh
                              dw                            0FFDh, 1000h, 1003h, 1006h, 1009h, 100Ch, 100Fh, 1012h
                              dw                            1015h, 1018h, 101Bh, 101Eh, 1021h, 108Ah, 108Ch, 108Eh
                              dw                            10CFh, 1196h, 119Eh, 11AEh, 11BAh, 1223h, 1230h, 12B8h
                              dw                            12CBh, 12EAh, 12F5h, 12FEh, 1306h, 1361h, 13E1h, 13F2h
                              dw                            140Bh, 1410h, 141Bh, 1421h, 142Fh, 1457h, 1482h, 149Ah
                              dw                            14E5h, 14FCh, 1505h, 164Ah, 1661h, 166Ah, 1704h, 1714h
                              dw                            1733h, 1738h, 1746h, 174Ch, 175Dh, 1788h, 17B9h, 17D4h
                              dw                            1822h, 1839h, 1842h, 1985h, 199Ch, 19A5h, 1A3Ah, 1A4Ch
                              dw                            1A61h, 1A6Bh, 1A76h, 1B0Ch, 1B1Dh, 1B27h, 1B37h, 1B45h
                              dw                            1B50h, 1B68h, 1B7Ah, 1B85h, 1B98h, 1BB3h, 1BBDh, 1BC8h
                              dw                            1BD9h, 1BE2h, 1BEFh, 1BFDh, 1C06h, 1C18h, 1C34h, 1C3Dh
                              dw                            1C7Bh, 1CB7h, 1CC0h, 1CD0h, 1CD9h, 1CE6h, 1CEFh, 1D31h
                              dw                            1D69h, 1D7Ch, 1D85h, 1D93h, 1DA1h, 1DAAh, 1DB9h, 1DF8h
                              dw                            1E0Bh, 1E14h, 1E22h, 1E30h, 1E39h, 1E8Fh, 1E98h, 1F3Ch
                              dw                            1F4Dh, 1F57h, 1F68h, 1F76h, 1F81h, 1F9Bh, 1FACh, 1FBFh
                              dw                            1FC9h, 1FDFh, 1FF2h, 1FFFh, 2017h, 2019h, 2033h, 204Fh
                              dw                            2058h, 20AAh, 20F1h, 210Ah, 211Fh, 2128h, 217Eh, 21CDh
                              dw                            21DAh, 21F0h, 21F2h, 2208h, 2246h, 2259h, 2262h, 2270h
                              dw                            227Eh, 2287h, 22E2h, 2397h, 23A8h, 23B2h, 23C3h, 23D1h
                              dw                            23DCh, 23F6h, 2407h, 241Dh, 2427h, 244Ah, 244Dh, 244Fh
                              dw                            2466h, 2480h, 2483h, 2485h, 24AEh, 24B1h, 24B3h, 24D1h
                              dw                            24EDh, 24F6h, 254Ah, 25D1h, 25D4h, 25D6h, 25FFh, 2602h
                              dw                            2604h, 261Ch, 2625h, 267Ch, 26C7h, 26E1h, 26E4h, 26E6h
                              dw                            270Dh, 2710h, 2712h, 272Ch, 276Ch, 277Fh, 2788h, 2796h
                              dw                            27A4h, 27ADh, 2835h, 2838h, 283Ah, 290Ch, 291Dh, 2927h
                              dw                            2938h, 2946h, 2951h, 296Bh, 297Ch, 2992h, 299Ch, 29BFh
                              dw                            29C3h, 29DCh, 29DFh, 29E5h, 2A02h, 2A1Ch, 2A20h, 2A39h
                              dw                            2A3Ch, 2A42h, 2A6Eh, 2A72h, 2A7Ch, 2A96h, 2A99h, 2A9Bh
                              dw                            2AC4h, 2AE0h, 2AE9h, 2B3Dh, 2BC4h, 2BC8h, 2BE1h, 2BE4h
                              dw                            2BEAh, 2C18h, 2C1Ch, 2C35h, 2C38h, 2C3Eh, 2C5Bh, 2C64h
                              dw                            2CBCh, 2D07h, 2D21h, 2D25h, 2D3Eh, 2D41h, 2D47h, 2D73h
                              dw                            2D77h, 2D81h, 2D9Bh, 2D9Eh, 2DA0h, 2DC5h, 2E05h, 2E18h
                              dw                            2E21h, 2E2Fh, 2E3Dh, 2E46h, 2ECEh, 2ED2h, 2EEBh, 2EEEh
                              dw                            2EF4h, 2FCFh, 2FE0h, 2FEAh, 2FFAh, 3008h, 3013h, 302Bh
                              dw                            303Dh, 3048h, 305Bh, 307Ch, 3080h, 3099h, 309Ch, 30A2h
                              dw                            30B7h, 30CFh, 30D3h, 30ECh, 30EFh, 30F5h, 3118h, 311Ch
                              dw                            3126h, 3138h, 313Bh, 313Dh, 315Eh, 317Ah, 3183h, 31C0h
                              dw                            3203h, 3207h, 3220h, 3223h, 3229h, 3249h, 324Dh, 3266h
                              dw                            3269h, 326Fh, 3285h, 328Eh, 32D0h, 3308h, 3322h, 3326h
                              dw                            333Fh, 3342h, 3348h, 336Ch, 3370h, 337Ah, 338Ch, 338Fh
                              dw                            3391h, 33AFh, 33ECh, 33FFh, 3408h, 3416h, 3424h, 342Dh
                              dw                            3488h, 348Ch, 34A5h, 34A8h, 34AEh, 3583h, 3594h, 359Eh
                              dw                            35AEh, 35BCh, 35C7h, 35DFh, 35F1h, 35FCh, 360Eh, 362Fh
                              dw                            3632h, 3634h, 3643h, 365Bh, 365Eh, 3660h, 3671h, 367Eh
                              dw                            3681h, 3683h, 3699h, 36B5h, 36BEh, 36FCh, 373Fh, 3742h
                              dw                            3744h, 375Fh, 3762h, 3764h, 3775h, 377Eh, 37C0h, 37F8h
                              dw                            3812h, 3815h, 3817h, 3829h, 3836h, 3839h, 383Bh, 384Eh
                              dw                            388Bh, 389Eh, 38A7h, 38B5h, 38C3h, 38CCh, 3927h, 392Ah
                              dw                            392Ch, 3999h, 39B2h, 39CBh, 39E4h, 3A0Ch, 3A16h, 3A50h
                              dw                            3A69h, 3A82h, 3A9Bh, 3BFFh, 3C18h, 3C35h, 3C3Fh, 3C87h
                              dw                            3D0Eh, 3D18h, 3D1Bh, 3D1Dh
                              dw                            3948h-403Ah
                              dw                            0014h, 0021h, 003Ah, 0047h, 0060h
                              dw                            394Fh-403Ah
                              dw                            0027h, 002Ch, 0031h, 0036h, 003Bh, 0043h, 0047h, 004Fh
                              dw                            005Dh, 007Bh, 0080h, 00A9h, 00B3h, 00C4h, 00D0h, 00D7h
                              dw                            00E7h, 0106h, 010Ah, 0124h, 012Eh
                              dw                            39F0h-403Ah
                              dw                            007Dh, 0083h, 009Eh, 00BFh, 00C5h
                              dw                            39FDh-403Ah
                              dw                            001Eh, 0024h, 01A0h, 01CBh, 01E5h, 0203h, 021Eh, 0224h
                              dw                            3A41h-403Ah
                              dw                            0104h, 014Bh, 0156h, 0174h
                              dw                            0

u72_end_patch                 dw                            1347h
                              dw                            121Fh-1347h
                              dw                            002Eh, 00B3h, 00B5h, 012Eh, 0130h, 0164h, 0194h, 01BFh
                              dw                            01E9h, 0213h, 023Dh, 027Eh, 02CAh, 02D2h, 030Fh, 0317h
                              dw                            0373h, 037Dh, 03CFh, 03D9h, 049Bh, 04A6h, 04FAh, 0504h
                              dw                            0558h, 0562h, 05AAh, 05ECh, 0630h, 066Ch, 066Fh, 0672h
                              dw                            0675h, 0678h, 067Bh, 067Eh, 0681h, 0684h, 0687h, 068Ah
                              dw                            068Dh, 0690h, 0693h, 0696h, 0699h, 069Ch, 069Fh, 06A2h
                              dw                            06A5h, 06A8h, 06ABh, 06AEh, 06B1h, 06B4h, 06B7h, 06BAh
                              dw                            06BDh, 06C0h, 06C3h, 06C6h, 06C9h, 06CCh, 06CFh, 06D2h
                              dw                            06D5h, 06D8h, 06DBh, 06DEh, 06E1h, 06E4h, 06E7h, 06EAh
                              dw                            06EDh, 06F0h, 06F3h, 06F6h, 06F9h, 06FCh, 06FFh, 0702h
                              dw                            0705h, 0708h, 070Bh, 070Eh, 0711h, 0714h, 0717h, 071Ah
                              dw                            071Dh, 0720h, 0723h, 0726h, 0729h, 072Ch, 072Fh, 0732h
                              dw                            0735h, 0738h, 073Bh, 073Eh, 0741h, 0744h, 0747h, 074Ah
                              dw                            074Dh, 0750h, 0753h, 0756h, 0759h, 07C0h, 07C2h, 07C4h
                              dw                            0803h
                              dw                            12E1h-1347h
                              dw                            00FEh, 0142h, 014Dh, 016Bh
                              dw                            0

;====================================================================================================================================================;
;
; Dispatcher Stack
;
;====================================================================================================================================================;
                              align                         4
stack_area_1                  db                            512 dup(21h)
stack_area_2                  db                            512 dup(21h)

text_end                      =                             $
text                          ends
                              end                           dispatcher
