;----------------------------------------------------------------------------------------------------------------------------------------------------;
;  U7RUN.ASM                                                                                                                                         ;
;    Scheduler COM to run the Ultima 7 family of games under Windows 9x, uses U7VXD.VXD                                                              ;
;    Gilbert ROUQUI, August 1, 2000                                                                                                                 ;
;  To run : U7RUN or U7RUN ABCDAlt-255 (Cheat mode Black Gate) or U7RUN manimal (Cheat Mode Serpent Isle)                                            ;
;  Compile -D options : -DTRACE enables an event TRACE (program scheduling, int 21 and 2f events)                                                    ;
;----------------------------------------------------------------------------------------------------------------------------------------------------;

;====================================================================================================================================================;

                              title                         U7RUN - Ultima7 Dispatcher for Windows 9x

;====================================================================================================================================================;
;                             I N C L U D E S
;====================================================================================================================================================;

                              .586p
                              .xlist
                              .list

;====================================================================================================================================================;
;                             E Q U A T E S
;====================================================================================================================================================;

;====================================================================================================================================================;
;                             M A I N                       C O D E
;====================================================================================================================================================;

text                          segment                       para public use16 'CODE'

                              assume                        cs:text, ds:text
                              db                            100h dup(?)

;====================================================================================================================================================;
;
; dispatcher - Schedules the EXEs from the game, according each one's returm code
;
;====================================================================================================================================================;

dispatcher                    proc                          near
                              mov                           dx, ds
                              mov                           ah, 4ah
                              mov                           bx, offset text_end
                              add                           bx, 000fh
                              shr                           bx, 04h
                              int                           21h
                              mov                           sp, offset text_end
                              mov                           ah, 09h
                              mov                           dx, offset msg_banner
                              int                           21h

                              mov                           ah, 0fh
                              int                           10h
                              mov                           video_state, al
                              mov                           ah, 00h
                              mov                           al, 13h
                              int                           10h

                              call                          interrupt_set
                              call                          driver_unload
                              jc                            program_wait_fail
                              call                          driver_load
                              jc                            program_wait_fail

                              mov                           al, 0ah

dispatch_loop:
                              xor                           esi, esi
IFDEF TRACE
                              mov                           extra_data, esi
                              call                          machine_dump
ENDIF
dispatch_01:
                              cmp                           al, 01h
                              jnz                           dispatch_06
                              jmp                           dispatch_return

dispatch_06:
                              cmp                           al, 06h
                              jnz                           dispatch_02
                              mov                           executable_state, 02h
                              mov                           di, offset pgm_intro
                              mov                           si, offset arg_psw_u71
                              test                     byte ptr is_u72, 01h
                              jz                            dispatch_06_u71
                              mov                           si, offset arg_psw_u72
dispatch_06_u71:
                              call                          program_wait
                              jc                            dispatch_load_fail
                              jmp                           dispatch_loop

dispatch_02:
                              cmp                           al, 02h
                              jnz                           dispatch_03
                              mov                           executable_state, 01h
                              mov                           di, offset pgm_menu
                              mov                           si, offset arg_v
                              call                          program_wait
                              jc                            dispatch_load_fail
                              jmp                           dispatch_loop

dispatch_03:
                              cmp                           al, 03h
                              jnz                           dispatch_04
                              mov                           executable_state, 03h
                              mov                           di, offset pgm_u71
                              test                     byte ptr is_u72, 01h
                              jz                            dispatch_03_u71
                              mov                           di, offset pgm_u72
dispatch_03_u71:
                              xor                           bx, bx
                              mov                           bl, ds:[0080h]
                              cmp                           bx, 7ch
                              jl                            dispatch_03_ovf
                              sub                           bx, 03h
dispatch_03_ovf:
                              add                           bx, 0081h
                              mov                      byte ptr ds:[bx], 20h
                              inc                           bx
                              mov                      byte ptr ds:[bx], 70h
                              inc                           bx
                              mov                      byte ptr ds:[bx], 00h
                              mov                           si, 0081h
                              call                          program_wait
                              jc                            dispatch_load_fail
                              jmp                           dispatch_loop

dispatch_04:
                              cmp                           al, 04h
                              jnz                           dispatch_05
                              mov                           executable_state, 04h
                              mov                           di, offset pgm_end
                              mov                           si, offset arg_psw_u71
                              test                     byte ptr is_u72, 01h
                              jz                            dispatch_04_u71
                              mov                           si, offset arg_psw_u72
dispatch_04_u71:
                              call                          program_wait
                              jc                            dispatch_load_fail
                              jmp                           dispatch_loop

dispatch_05:
                              cmp                           al, 05h
                              jnz                           dispatch_07
                              mov                           executable_state, 01h
                              mov                           di, offset pgm_menu
                              mov                           si, offset arg_n
                              call                          program_wait
                              jc                            dispatch_load_fail
                              jmp                           dispatch_exit

dispatch_07:
                              cmp                           al, 07h
                              jnz                           dispatch_08
                              mov                           executable_state, 01h
                              mov                           di, offset pgm_menu
                              mov                           si, offset arg_c
                              call                          program_wait
                              jc                            dispatch_load_fail
                              jmp                           dispatch_loop

dispatch_08:
                              cmp                           al, 08h
                              jnz                           dispatch_0a
                              mov                           executable_state, 01h
                              mov                           di, offset pgm_extra
                              mov                           si, offset arg_u1
                              call                          program_wait
                              jc                            dispatch_load_fail
                              jmp                           dispatch_loop

dispatch_0a:
                              cmp                           al, 0ah
                              jnz                           dispatch_09
                              mov                           executable_state, 01h
                              mov                           di, offset pgm_menu
                              mov                           si, offset arg_m
                              call                          program_wait
                              jc                            dispatch_load_fail
                              jmp                           dispatch_loop

dispatch_09:
                              cmp                           al, 09h
                              jnz                           dispatch_exit
                              mov                           executable_state, 01h
                              mov                           di, offset pgm_menu
                              mov                           si, offset arg_l
                              call                          program_wait
                              jc                            dispatch_load_fail
                              jmp                           dispatch_loop

dispatch_load_fail:
                              push                          ax
                              mov                           ah, 00h
                              mov                           al, video_state
                              int                           10h
                              pop                           ax
                              mov                           dx, offset msg_error
                              jmp                           dispatch_exit_msg

dispatch_exit:
                              mov                           ah, 0fh
                              int                           10h
                              cmp                           video_state, al
                              je                            dispatch_exit_video
                              mov                           ah, 00h
                              mov                           al, video_state
                              int                           10h

dispatch_exit_video:
                              xor                           ax, ax
                              mov                           dx, offset msg_exit_u71
                              test                     byte ptr is_u72, 01
                              jz                            dispatch_exit_msg
                              mov                           dx, offset msg_exit_u72
dispatch_exit_msg:
                              push                          ax
                              mov                           ah, 09h
                              int                           21h
                              pop                           ax
dispatch_return:
IFDEF TRACE
                              mov                     dword ptr extra_data, 00000000h
                              call                          machine_dump
ENDIF
                              call                          driver_unload
                              push                          ax
                              push                          ds
                              lds                           dx, dword ptr [00h+int_21]
                              mov                           ax, 2521h
                              int                           21h
                              pop                           ds
                              push                          ds
                              lds                           dx, dword ptr [00h+int_2f]
                              mov                           ax, 252fh
                              int                           21h
                              pop                           ds
                              pop                           ax
                              mov                           ah, 4ch
IFDEF TRACE
                              call                          machine_dump
ENDIF
                              int                           21h
dispatcher                    endp

;====================================================================================================================================================;
;
; interrupt_set - Hooks software interrupts 21 for code 3Dxx Open, and interrupt 2f for code 4310 Locate XMS
;
;====================================================================================================================================================;

interrupt_set                 proc                          near
                              push                          es
                              push                          ax
                              mov                           ax, 3521h
                              int                           21h
                              mov                      word ptr [00h+int_21], bx
                              mov                      word ptr [02h+int_21], es
IFDEF TRACE
                              mov                     dword ptr extra_data, 00000000h
                              call                          machine_dump
ENDIF
                              mov                           ax, 352fh
                              int                           21h
                              mov                      word ptr [00h+int_2f], bx
                              mov                      word ptr [02h+int_2f], es
IFDEF TRACE
                              call                          machine_dump
ENDIF
                              mov                           ax, 4100h
                              mov                           dx, offset xmmhand_dat
                              int                           21h
IFDEF TRACE
                              call                          machine_dump
ENDIF
                              mov                           dx, offset interrupt_21
                              mov                           ax, 2521h
                              int                           21h
                              mov                           dx, offset interrupt_2f
                              mov                           ax, 252fh
                              int                           21h
                              mov                           ax, 3d00h
                              mov                           dx, offset pgm_u72
                              int                           21h
                              jc                            interrupt_set_end
                              mov                           bx, ax
                              mov                           ah, 3eh
                              int                           21h
                              mov                      byte ptr is_u72, 01
interrupt_set_end:
                              pop                           ax
                              pop                           es
IFDEF TRACE
                              call                          machine_dump
ENDIF
                              ret
interrupt_set                 endp

;====================================================================================================================================================;
;
; program_run - Runs one of the EXEs from the GAME, prepares the command string and the PSP, and issues interrupt 21 code 4B00
;
;====================================================================================================================================================;

program_run                   proc                          near
                              push                          bx
                              push                          cx
                              push                          dx
                              push                          ds
                              push                          si
                              push                          es
                              push                          di
                              push                          bp
                              mov                           bp, sp
                              sub                           sp, 0094h
                              push                          ss
                              pop                           es
                              mov                           di, sp
                              inc                           di
                              push                          di
                              mov                           ax, 007fh
                              mov                           cx, ax
                          rep movs                     byte ptr es:[di], ds:[si]
                              xchg                          ax, cx
                              mov                           ah, cl
                              pop                           di
                        repne scas                     byte ptr es:[di]
                              inc                           cx
                              sub                           ah, cl
                              mov                           ss:[-94h+bp], ah          ; -94 argument size, -93..-15 argument
                              dec                           di
                              mov                           al, 0dh
                              stos                     byte ptr es:[di]
                              mov                      word ptr ss:[-0eh+bp], 0000h   ; -0e..-0d Environment Segment
                              mov                           ss:[-0ch+bp], sp          ; -0c..-09 Command Parameters
                              mov                           ss:[-0ah+bp], ss          ; bp - 0094 = sp
                              mov                      word ptr ss:[-08h+bp], 005ch   ; -08..-05 First  FCB
                              mov                           ss:[-06h+bp], es
                              mov                      word ptr ss:[-04h+bp], 006ch   ; -04..-01 Second FCB
                              mov                           ss:[-02h+bp], es
                              mov                           ah, 2fh
                              int                           21h
                              mov                           ss:[-14h+bp], bx          ; -14..-11 DTA
                              mov                           ss:[-12h+bp], es
                              mov                           ax, 3300h
                              int                           21h
                              mov                           ss:[-10h+bp], dl          ; -10 Flag Break
                              push                          bp
                              mov                           old_sp, sp
                              mov                           old_ss, ss
                              mov                           dx, ss:[02h+bp]           ; Argument : Program Name
                              mov                           ds, ss:[04h+bp]
                              mov                           bx, bp                    ; -0e Parameter Table
                              sub                           bx, 0eh
                              push                          ss
                              pop                           es
                              mov                           ax, 4b00h
                              int                           21h
                              xchg                          ax, bx                    ; bx <- return code
                              lahf
                              xchg                          ax, cx                    ; cx <- flags
                              mov                           dx, cs
                              mov                           ds, dx
                              cli
                              mov                           sp, old_sp
                              mov                           ss, old_ss
                              sti
                              pop                           bp
                              mov                           dl, ss:[-10h+bp]          ; Restore Flag Break
                              mov                           ax, 3301h
                              int                           21h
                              lds                           dx, ss:[-14h+bp]          ; Restore DTA
                              mov                           ah, 1ah
                              int                           21h
                              xchg                          ax, cx                    ; restore int 21/4b flags
                              sahf
                              xchg                          ax, bx                    ; restore int 21/4b return code
                              mov                           sp, bp
                              pop                           bp
                              pop                           di
                              pop                           es
                              pop                           si
                              pop                           ds
                              pop                           dx
                              pop                           cx
                              pop                           bx
                              ret
program_run                   endp

;====================================================================================================================================================;
;
; program_wait - Loads the VXD, Runs a GAME EXE with program_run above, Gets return code with interrupt 21 code 4d00, Unloads the VXD
;
;====================================================================================================================================================;

program_wait                  proc                          near
                              
                              mov                           ax, 4100h
                              mov                           dx, offset xmmhand_dat
                              int                           21h

                              mov                           ax, 4100h
                              mov                           dx, offset temp0003_dol
                              int                           21h

                              mov                           interrupt_state, 01h
                              call                          program_run
                              mov                           interrupt_state, 0
IFDEF TRACE
                              mov                     dword ptr extra_data, 00000000h
                              call                          machine_dump
ENDIF
                              jc                            program_wait_fail
                              mov                           ah, 4dh
                              int                           21h
IFDEF TRACE
                              call                          machine_dump
ENDIF
                              ret
program_wait_fail:
                              stc
IFDEF TRACE
                              call                          machine_dump
ENDIF
                              ret
program_wait                  endp

;====================================================================================================================================================;
;
; driver_load - Dynamically loads U7VXD.VXD using a V86 API call to VXDLDR, itself located as VXD Device 00000027h
;
;====================================================================================================================================================;

driver_load                   proc                          near

                              push                          si
                              push                          ax
                              mov                           bx, 27h
                              mov                           ax, 1684h
                              push                          es
                              push                          di
                              int                           2fh
                              mov                      word ptr vxdldr_proc+0, di
                              mov                      word ptr vxdldr_proc+2, es
IFDEF TRACE
                              mov                     dword ptr extra_data, 00000000h
                              call                          machine_dump
ENDIF
                              mov                           ax, es
                              or                            ax, di
                              jz                            driver_load_fail
                              mov                           ax, 1
                              push                          ds
                              pop                           es
                              mov                           dx, offset u7vxd_long_name
                              call                    dword ptr [vxdldr_proc]
IFDEF TRACE
                              call                          machine_dump
ENDIF
                              or                            ax, ax
                              jnz                           driver_load_fail
                              pop                           di
                              pop                           es
                              pop                           ax
                              pop                           si
                              clc
IFDEF TRACE
                              call                          machine_dump
ENDIF
                              ret
driver_load_fail: 
                              pop                           di
                              pop                           es
                              pop                           ax
                              pop                           si
                              stc
IFDEF TRACE
                              call                          machine_dump
ENDIF
                              ret
driver_load                   endp

;====================================================================================================================================================;
;
; driver_unload - Dynamically unloads U7VXD.VXD using a V86 API call to VXDLDR, itself located as VXD Device 00000027h
;
;====================================================================================================================================================;

driver_unload                 proc                          near
                              push                          si
                              push                          ax
                              mov                           bx, 27h
                              mov                           ax, 1684h
                              push                          es
                              push                          di
                              int                           2fh
                              mov                      word ptr vxdldr_proc+0, di
                              mov                      word ptr vxdldr_proc+2, es
IFDEF TRACE
                              mov                     dword ptr extra_data, 00000000h
                              call                          machine_dump
ENDIF
                              mov                           ax, es
                              or                            ax, di
                              jz                            driver_unload_fail
driver_unload_redo:
                              mov                           ax, 2
                              mov                           bx, 0ffffh
                              push                          ds
                              pop                           es
                              mov                           dx, offset u7vxd_short_name
                              call                    dword ptr [vxdldr_proc]
IFDEF TRACE
                              call                          machine_dump
ENDIF
                              or                            ax, ax
                              jz                            driver_unload_redo
                              pop                           di
                              pop                           es
                              pop                           ax
                              pop                           si
                              clc
IFDEF TRACE
                              call                          machine_dump
ENDIF
                              ret
driver_unload_fail:
                              pop                           di
                              pop                           es
                              pop                           ax
                              pop                           si
                              stc
IFDEF TRACE
                              call                          machine_dump
ENDIF
                              ret
driver_unload                 endp

IFDEF TRACE
;====================================================================================================================================================;
;
; machine_dump - Debugging help, writes all registers on a trace_file
;
;====================================================================================================================================================;

machine_dump                  proc                          near
                              push                          esp
                              push                          ebp
                              movzx                         ebp, sp
                              push                          ds
                              push                          cs
                              pop                           ds
                              pushfd
                              pushad

                              mov                           si, offset trace_file
                              xor                           cx, cx
                              mov                           bx, 0001h
                              mov                           dx, 0011h
                              mov                           ax, 6c00h
                              int                           21h
                              jc                            machine_dump_fail

                              mov                           bx, ax
                              mov                           ax, 4202h
                              xor                           cx, cx
                              xor                           dx, dx
                              int                           21h
                              jc                            machine_dump_exit

                              mov                           esi, dword ptr ss:[-0ah+ebp]
                              mov                           dx, offset trace_eax
                              mov                           cx, offset trace_separ
                              call                          machine_dump_dword_separ

                              mov                           esi, dword ptr ss:[-16h+ebp]
                              mov                           dx, offset trace_ebx
                              mov                           cx, offset trace_separ
                              call                          machine_dump_dword_separ

                              mov                           esi, dword ptr ss:[-0eh+ebp]
                              mov                           dx, offset trace_ecx
                              mov                           cx, offset trace_separ
                              call                          machine_dump_dword_separ

                              mov                           esi, dword ptr ss:[-12h+ebp]
                              mov                           dx, offset trace_edx
                              mov                           cx, offset trace_separ
                              call                          machine_dump_dword_separ

                              mov                           si, es
                              mov                           dx, offset trace_es
                              mov                           cx, offset trace_separ
                              call                          machine_dump_seg_separ

                              mov                           si, cs
                              mov                           dx, offset trace_cs
                              mov                           cx, offset trace_separ
                              call                          machine_dump_seg_separ

                              mov                           si, word ptr ss:[+08h+ebp]
                              mov                           dx, offset trace_ip
                              mov                           cx, offset trace_separ
                              call                          machine_dump_word_separ

                              mov                           si, ss
                              mov                           dx, offset trace_ss
                              mov                           cx, offset trace_separ
                              call                          machine_dump_seg_separ

                              mov                           si, fs
                              mov                           dx, offset trace_fs
                              mov                           cx, offset trace_separ
                              call                          machine_dump_seg_separ

                              mov                           si, gs
                              mov                           dx, offset trace_gs
                              mov                           cx, offset trace_line
                              call                          machine_dump_seg_separ

                              mov                           esi, dword ptr ss:[-22h+ebp]
                              mov                           dx, offset trace_esi
                              mov                           cx, offset trace_separ
                              call                          machine_dump_dword_separ

                              mov                           esi, dword ptr ss:[-26h+ebp]
                              mov                           dx, offset trace_edi
                              mov                           cx, offset trace_separ
                              call                          machine_dump_dword_separ

                              mov                           esi, dword ptr ss:[+00h+ebp]
                              mov                           dx, offset trace_ebp
                              mov                           cx, offset trace_separ
                              call                          machine_dump_dword_separ

                              mov                           esi, dword ptr ss:[+04h+ebp]
                              mov                           dx, offset trace_esp
                              mov                           cx, offset trace_separ
                              call                          machine_dump_dword_separ

                              mov                           si, word ptr ss:[-02h+ebp]
                              mov                           dx, offset trace_ds
                              mov                           cx, offset trace_separ
                              call                          machine_dump_seg_separ

                              mov                           esi, extra_data
                              or                            esi, esi
                              jnz                           machine_dump_with_extra

                              mov                           esi, dword ptr ss:[-06h+ebp]
                              mov                           dx, offset trace_eflags
                              mov                           cx, offset trace_line
                              call                          machine_dump_dword_separ

                              jmp                           machine_dump_exit
machine_dump_with_extra:
                              mov                           esi, dword ptr ss:[-06h+ebp]
                              mov                           dx, offset trace_eflags
                              mov                           cx, offset trace_separ
                              call                          machine_dump_dword_separ

                              mov                           esi, extra_data
                              mov                           dx, offset trace_extra
                              mov                           cx, offset trace_line
                              call                          machine_dump_dword_separ

                              jmp                           machine_dump_exit

machine_dump_call_exit:
                              pop                           ax
machine_dump_exit:
                              mov                           ah, 3eh
                              int                           21h
machine_dump_fail:
                              popad
                              popfd
                              pop                           ds
                              pop                           ebp
                              pop                           esp
                              ret

machine_dump_dword_separ:
                              push                          cx
                              call                          dword_dump
                              pop                           dx
                              jc                            machine_dump_call_exit
                              call                          separ_dump
                              jc                            machine_dump_call_exit
                              ret

machine_dump_word_separ:
                              push                          cx
                              call                          word_dump
                              pop                           dx
                              jc                            machine_dump_call_exit
                              call                          separ_dump
                              jc                            machine_dump_call_exit
                              ret

machine_dump_seg_separ:
                              push                          cx
                              call                          word_dump
                              pop                           dx
                              jc                            machine_dump_call_exit
                              call                          separ_dump
                              jc                            machine_dump_call_exit
                              ret
machine_dump                  endp

;====================================================================================================================================================;
;
; dword_dump - Helper for machine_dump, equivalent to sprintf // %08lx
;
;====================================================================================================================================================;

dword_dump                    proc                          near
                              mov                           cx, 0003h
                              mov                           ah, 40h
                              int                           21h
dword_dump_noheader:
                              mov                           cx, 20h
                              mov                           di, offset trace_buffer
dword_dump_loop:
                              jcxz                          dword_dump_exit
                              sub                           cl, 04h
                              inc                           di
                              mov                           eax, esi
                              shr                           eax, cl
                              and                           al, 0fh
                              add                           al, 30h
                              cmp                           al, 3ah
                              jl                            dword_dump_1
                              add                           al, 07h
dword_dump_1:
                              mov                           ds:[02h+di], al
                              jmp                           dword_dump_loop
dword_dump_exit:
                              mov                           cx, 0bh
                              mov                           dx, offset trace_buffer
                              mov                           ah, 40h
                              int                           21h
                              ret
dword_dump                    endp

;====================================================================================================================================================;
;
; word_dump - Helper for machine_dump, equivalent to sprintf // %04x
;
;====================================================================================================================================================;

word_dump                     proc                          near
                              mov                           cx, 0002h
                              mov                           ah, 40h
                              int                           21h
word_dump_noheader:
                              mov                           cx, 10h
                              mov                           di, offset trace_buffer
word_dump_loop:
                              jcxz                          word_dump_exit
                              sub                           cl, 04h
                              inc                           di
                              mov                           ax, si
                              shr                           ax, cl
                              and                           al, 0fh
                              add                           al, 30h
                              cmp                           al, 3ah
                              jl                            word_dump_1
                              add                           al, 07h
word_dump_1:
                              mov                           ds:[02h+di], al
                              jmp                           word_dump_loop
word_dump_exit:
                              mov                           cx, 07h
                              mov                           dx, offset trace_buffer
                              mov                           ah, 40h
                              int                           21h
                              ret
word_dump                     endp

;====================================================================================================================================================;
;
; separ_dump - Helper for machine_dump, equivalent to sprintf // %2.2s
;
;====================================================================================================================================================;

separ_dump                    proc                          near
                              mov                           cx, 0002h
                              mov                           ah, 40h
                              int                           21h
                              ret
separ_dump                    endp
ENDIF

;====================================================================================================================================================;
;                             H O O K                       C O D E
;====================================================================================================================================================;

                              assume                        cs:text, ds:nothing

;====================================================================================================================================================;
;
; interrupt_21 - Traps an Open on EMMXXXX0, then answers not found, passes through all other requests
;
;====================================================================================================================================================;

interrupt_21                  proc                          near
                              push                          bp
                              mov                           bp, sp
                              push                          bx
                              pushf
                              cmp                           interrupt_state, 0
                              je                            interrupt_21_propagate
IFDEF TRACE
                              cmp                           ah, 3dh
                              je                            interrupt_21_trace
                              cmp                           ah, 3eh
                              je                            interrupt_21_trace
                              cmp                           ah, 3fh
                              jne                           interrupt_21_propagate
interrupt_21_trace:
                              push                          eax
                              shl                           eax, 16
                              mov                           ax, 0301h
                              db                            0cch, 000h
                              pop                           eax
ENDIF
                              cmp                           ah, 3dh
                              jne                           interrupt_21_propagate
                              mov                           bx, dx
                              cmp                     dword ptr ds:[00h+bx], 584d4d45h
                              jne                           interrupt_21_propagate
                              cmp                     dword ptr ds:[04h+bx], 30585858h
                              jne                           interrupt_21_propagate

                              or                       byte ptr ss:[06h+bp], 01h
                              mov                           al, 02h
IFDEF TRACE
                              push                          eax
                              mov                           eax, dword ptr ss:[02h+bp]
                              mov                           extra_data, eax
                              pop                           eax
                              mov                           interrupt_state, 00h
                              call                          machine_dump
                              mov                           interrupt_state, 01h
ENDIF
                              popf
                              pop                           bx
                              pop                           bp
                              iret

interrupt_21_propagate:
                              popf
                              pop                           bx
                              pop                           bp
                              jmp                     dword ptr cs:[int_21]
interrupt_21                  endp

;====================================================================================================================================================;
;
; interrupt_2f - Traps on Locate XMS, passes through all other requests
;
;====================================================================================================================================================;

interrupt_2f                  proc                          near
                              push                          bp
                              mov                           bp, sp
                              push                          es
                              pushf
                              cmp                           interrupt_state, 00h
                              je                            interrupt_2f_propagate
                              cmp                           ax, 4310h
                              jne                           interrupt_2f_propagate
IFDEF TRACE
                              push                          eax
                              mov                           eax, dword ptr ss:[02h+bp]
                              mov                           extra_data, eax
                              pop                           eax
                              mov                           interrupt_state, 00h
                              call                          machine_dump
                              mov                           interrupt_state, 01h
ENDIF
                              call                    dword ptr cs:[int_2f]
                              mov                      word ptr [00h+xms_hd], bx
                              mov                      word ptr [02h+xms_hd], es
                              pop                           es
                              push                          cs
                              pop                           es
                              mov                           bx, offset xms_handler
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump
                              mov                           interrupt_state, 01h
ENDIF
                              pop                           bp
                              iret

interrupt_2f_propagate:
                              popf
                              pop                           es
                              pop                           bp
                              jmp                     dword ptr cs:[int_2f]
interrupt_2f                  endp

;====================================================================================================================================================;
;
; xms_handler - Service given as XMS Routine, traps on Allocate 0900, Free 0a00, Lock 0c00, Unlock 0d00
;               Upon Allocate, sends the memory  request to the VXD for _PageAllocate
;               Upon Free,     sends the memory  request to the VXD for _PageFree
;               Upon Lock,     sends a EXE patch request to the VXD, if the Patch fails, propagates an XMS Lock failure
;               Upon Unlock,   does nothing further
;
;====================================================================================================================================================;

xms_handler                   proc                          near
                              cmp                           interrupt_state, 00h
                              je                            xms_handler_propagate
IFDEF TRACE
                              cmp                           ah, 09h
                              je                            xms_handler_capture
                              cmp                           ah, 08h
                              je                            xms_handler_capture
                              cmp                           ah, 0ah
                              je                            xms_handler_capture
                              cmp                           ah, 0bh
                              je                            xms_handler_capture
                              cmp                           ah, 0ch
                              je                            xms_handler_capture
                              cmp                           ah, 0dh
                              jne                           xms_handler_propagate
xms_handler_capture:
                              push                          bp
                              mov                           bp, sp
                              push                          eax
                              mov                           eax, dword ptr ss:[02h+bp]
                              mov                           extra_data, eax
                              pop                           eax
                              pop                           bp
                              mov                           interrupt_state, 00h
                              call                          machine_dump
                              mov                           interrupt_state, 01h
ENDIF
                              cmp                           ah, 08h
                              je                            xms_handler_capture_08
                              cmp                           ah, 09h
                              je                            xms_handler_capture_09
                              cmp                           ah, 0ah
                              je                            xms_handler_capture_0a
                              cmp                           ah, 0bh
                              je                            xms_handler_capture_0b
                              cmp                           ah, 0ch
                              je                            xms_handler_capture_0c
                              cmp                           ah, 0dh
                              je                            xms_handler_capture_0d
                              jmp                           xms_handler_propagate

xms_handler_capture_08:
                              mov                           ax, 0400h
                              mov                           dx, 0400h
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump
                              mov                           interrupt_state, 01h
ENDIF
                              retf

xms_handler_capture_09:
                              mov                           bx, offset dpmi_block_00
                              cmp                      byte ptr cs:[00h+bx], 00h
                              je                            xms_handler_09_found
                              mov                           bx, offset dpmi_block_01
                              cmp                      byte ptr cs:[00h+bx], 00h
                              je                            xms_handler_09_found
                              mov                           bx, offset dpmi_block_02
                              cmp                      byte ptr cs:[00h+bx], 00h
                              je                            xms_handler_09_found
                              mov                           bx, offset dpmi_block_03
                              cmp                      byte ptr cs:[00h+bx], 00h
                              je                            xms_handler_09_found
xms_handler_09_fail:
                              mov                           bl, 0a0h
                              xor                           ax, ax
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump
                              mov                           interrupt_state, 01h
ENDIF
                              retf

xms_handler_09_found:
                              push                          bx
                              mov                           cx, dx
                              xor                           bx, bx
                              shld                          bx, cx, 0ah
                              shl                           cx, 0ah
                              mov                           ax, 0501h
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump
                              mov                           interrupt_state, 01h
ENDIF
                              db                            0cch, 00h
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump
                              mov                           interrupt_state, 01h
ENDIF
                              pop                           dx
                              jc                            xms_handler_09_fail
                              xchg                          dx, bx
                              mov                      byte ptr cs:[00h+bx], 01h
                              mov                      word ptr cs:[01h+bx], di
                              mov                      word ptr cs:[03h+bx], si
                              xchg                          dx, bx
                              mov                           ax, 0001h
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump
                              mov                           interrupt_state, 01h
ENDIF
                              retf

xms_handler_capture_0a:
                              push                          dx
                              xchg                          dx, bx
                              mov                           di, word ptr cs:[01h+bx]
                              mov                           si, word ptr cs:[03h+bx]
                              xchg                          dx, bx
                              mov                           ax, 0502h
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump
                              mov                           interrupt_state, 01h
ENDIF
                              db                            0cch, 00h
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump
                              mov                           interrupt_state, 01h
ENDIF
                              pop                           dx
                              jc                            xms_handler_0a_fail
                              xchg                          dx, bx
                              mov                      byte ptr cs:[00h+bx], 00h
                              xchg                          dx, bx
                              mov                           ax, 0001h
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump
                              mov                           interrupt_state, 01h
ENDIF
                              retf

xms_handler_0a_fail:
                              mov                           bl, 0a2h
                              xor                           ax, ax
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump
                              mov                           interrupt_state, 01h
ENDIF
                              retf

xms_handler_capture_0b:
                              pushad                
                              lods                    dword ptr ds:[si]
                              mov                           ecx, eax
xms_handler_copy_source:
                              lods                     word ptr ds:[si]
                              mov                           bx, ax
                              or                            bx, bx
                              jz                            xms_handler_copy_source_local
                              mov                           edx, dword ptr cs:[01h+bx]
                              lods                    dword ptr ds:[si]
                              add                           edx, eax
                              jmp                           xms_handler_copy_dest
xms_handler_copy_source_local:
                              lods                     word ptr ds:[si]
                              movzx                         edx, ax
                              lods                     word ptr ds:[si]
                              movzx                         eax, ax
                              shl                           eax, 4
                              add                           edx, eax
xms_handler_copy_dest:
                              lods                     word ptr ds:[si]
                              mov                           bx, ax
                              or                            bx, bx
                              jz                            xms_handler_copy_dest_local
                              mov                           edi, dword ptr cs:[01h+bx]
                              lods                    dword ptr ds:[si]
                              add                           edi, eax
                              jmp                           xms_handler_copy_execute
xms_handler_copy_dest_local:
                              lods                     word ptr ds:[si]
                              movzx                         edi, ax
                              lods                     word ptr ds:[si]
                              movzx                         eax, ax
                              shl                           eax, 4
                              add                           edi, eax
xms_handler_copy_execute:
                              mov                           esi, edx
                              push                          es
                              push                          ds
                              xor                           eax, eax
                              mov                           ds, ax
                              mov                           es, ax
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump
                              mov                           interrupt_state, 01h
ENDIF
                              db                            0cch, 42h, 00h
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump
                              mov                           interrupt_state, 01h
ENDIF
                              pop                           ds
                              pop                           es
                              popad
                              mov                           ax, 0001h
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump
                              mov                           interrupt_state, 01h
ENDIF
                              retf

xms_handler_capture_0c:
                              push                          ax
                              push                          bx
                              push                          cx
xms_handler_patch_u71:
                              test                          is_u72, 01h
                              jnz                           xms_handler_patch_u72
xms_handler_patch_main_u71:
                              cmp                           executable_state, 01h
                              jne                           xms_handler_patch_game_u71
                              mov                           bx, 0001h
                              jmp                           xms_handler_patch_start
xms_handler_patch_game_u71:
                              cmp                           executable_state, 03h
                              jne                           xms_handler_patch_end_u71
                              mov                           bx, 0002h
                              jmp                           xms_handler_patch_start
xms_handler_patch_end_u71:
                              cmp                           executable_state, 04h
                              jne                           xms_handler_patch_end
                              mov                           bx, 0003h
                              jmp                           xms_handler_patch_start

xms_handler_patch_u72:
xms_handler_patch_int_u72:
                              cmp                           executable_state, 02h
                              jne                           xms_handler_patch_main_u72
                              mov                           bx, 0010h
                              jmp                           xms_handler_patch_start
xms_handler_patch_main_u72:
                              cmp                           executable_state, 01h
                              jne                           xms_handler_patch_game_u72
                              mov                           bx, 0011h
                              jmp                           xms_handler_patch_start
xms_handler_patch_game_u72:
                              cmp                           executable_state, 03h
                              jne                           xms_handler_patch_end_u72
                              mov                           bx, 0012h
                              jmp                           xms_handler_patch_start
xms_handler_patch_end_u72:
                              cmp                           executable_state, 04h
                              jne                           xms_handler_patch_end
                              mov                           bx, 0013h
                              jmp                           xms_handler_patch_start

xms_handler_patch_start:
                              mov                           cx, ss
                              mov                           ax, 0401h
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump
                              mov                           interrupt_state, 01h
ENDIF
                              db                            0cch, 000h
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump
                              mov                           interrupt_state, 01h
ENDIF
                              jc                            xms_handler_patch_error

xms_handler_patch_end:
                              pop                           cx
                              pop                           bx
                              pop                           ax

                              xchg                          dx, bx
                              mov                           dx, word ptr cs:[03h+bx]
                              mov                           bx, word ptr cs:[01h+bx]
                              mov                           ax, 0001h
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump
                              mov                           interrupt_state, 01h
ENDIF
                              retf

xms_handler_patch_error:
                              pop                           cx
                              pop                           bx
                              pop                           ax

                              xchg                          dx, bx
                              mov                           ax, 0000h
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump
                              mov                           interrupt_state, 01h
ENDIF
                              retf

xms_handler_capture_0d:
                              mov                           ax, 0001h
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump
                              mov                           interrupt_state, 01h
ENDIF
                              retf

xms_handler_propagate:
IFDEF TRACE
                              mov                           interrupt_state, 00h
                              call                          machine_dump
                              mov                           interrupt_state, 01h
ENDIF
                              jmp                     dword ptr cs:[xms_hd]
xms_handler                   endp

;====================================================================================================================================================;
;                             M A I N                       D A T A
;====================================================================================================================================================;

IFDEF TRACE

;====================================================================================================================================================;
;
; Tracing fields for use by machine_dump
;
;====================================================================================================================================================;
                              align                         4
extra_data                    dd                            0
trace_file                    db                            "c:\u7run.log", 0
trace_buffer                  db                            " = 00000000"
trace_separ                   db                            ", "
trace_line                    db                            0dh, 0ah
trace_eax                     db                            "eax"
trace_ebx                     db                            "ebx"
trace_ecx                     db                            "ecx"
trace_edx                     db                            "edx"
trace_esp                     db                            "esp"
trace_ebp                     db                            "ebp"
trace_esi                     db                            "esi"
trace_edi                     db                            "edi"
trace_ip                      db                            "ip"
trace_eflags                  db                            "flg"
trace_extra                   db                            "ext"
trace_idt                     db                            "idt"
trace_gdt                     db                            "gdt"
trace_sw                      db                            "sw"
trace_lt                      db                            "lt"
trace_tr                      db                            "tr"
trace_ds                      db                            "ds"
trace_es                      db                            "es"
trace_ss                      db                            "ss"
trace_cs                      db                            "cs"
trace_fs                      db                            "fs"
trace_gs                      db                            "gs"
trace_rs                      db                            "rs"
trace_stack_1                 db                            "s1"
trace_stack_2                 db                            "s2"
trace_interrupt_code          db                            "ic"
trace_interrupt_occurs        db                            "occ"
trace_interrupt_location      db                            "loc"
ENDIF

;====================================================================================================================================================;
;
; Dispatcher Data proper
;
;====================================================================================================================================================;

msg_banner                    db                            "Ultima 7 Helper for Windows 9x, Version 0.5", 0dh, 0dh, 24h
pgm_intro                     db                            "intro.exe", 0
pgm_menu                      db                            "mainmenu.exe", 0
pgm_u71                       db                            "u7.exe", 0
msg_exit_u71                  db                            "Thank you for playing Ultima VII, The Black Gate!", 0dh, 0dh, 24h
arg_psw_u71                   db                            "ereiamjh", 0
pgm_u72                       db                            "si.exe", 0
msg_exit_u72                  db                            "Thank you for playing Ultima VII Part II : Serpent Isle!", 0dh, 0dh, 24h
arg_psw_u72                   db                            "hisss", 0
pgm_end                       db                            "endgame.exe", 0
pgm_extra                     db                            "surprise.exe", 0
arg_v                         db                            "v", 0
arg_n                         db                            "n", 0
arg_c                         db                            "c", 0
arg_l                         db                            "l", 0
arg_u1                        db                            "u1", 0
arg_m                         db                            "m", 0
arg_blank                     db                            " ", 0
arg_vr                        db                            "v r", 0
msg_error                     db                            "An error had occurred loading a program.", 0dh, 0dh, 24h
xmmhand_dat                   db                            "xmmhand.dat", 0
temp0003_dol                  db                            "temp0003.$$$", 0

;====================================================================================================================================================;
;
; Hooks and VXD Interface Data
;
;====================================================================================================================================================;

u7vxd_short_name              db                            "U7VXD", 0
u7vxd_long_name               db                            "U7VXD.VXD", 0

interrupt_state               db                            0
video_state                   db                            0
is_u72                        db                            0
executable_state              db                            0

                              align                         4

vxdldr_proc                   dd                            0
int_21                        dd                            0
int_2f                        dd                            0
xms_hd                        dd                            0
code_word                     dw                            0ffffh
old_sp                        dw                            0
old_ss                        dw                            0

dpmi_block_00                 db                            5 dup(0)
dpmi_block_01                 db                            5 dup(0)
dpmi_block_02                 db                            5 dup(0)
dpmi_block_03                 db                            5 dup(0)

;====================================================================================================================================================;
;
; Dispatcher Stack
;
;====================================================================================================================================================;
                              align                         4
u7_stack                      db                            512 dup (21h)
text_end                      =                             $
text                          ends
                              end                           dispatcher
